% function L = adjust_loadings(L)
%
% This functions performs 2 tasks:
% 1) normalization of each column of L to its norm so all loadings have unit norm
% 2) loadings flipping: makes all loadings sum to a positive value. This is an attempt to finish with upside down cases
%    due to instabilities in eigenvector calculation
function L = adjust_loadings(L)
for i = 1:size(L, 2)
    v = L(:, i);
    v = v/norm(v);
    if sum(v) < 0
        v = -v;
    end;
    L(:, i) = v;
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
