% function model = ann_boot(model, data)
%
% Creates and configures the net structure.
function model = ann_boot(model, data)

model = model_boot(model, data);

model.net = newpr(data.X', model_get_targets(model, data)', model.hiddens);
            
model.net.trainFcn = 'trainlm';
% model.net.initFcn = 'initwb';
model.net = init(model.net);
            
%Define learning parameters, these values can be changed
model.net.trainParam.goal = model.goal;
model.net.trainParam.epochs = model.epochs;
model.net.trainParam.show = model.show;
model.net.trainParam.lr = model.lr;
model.net.trainParam.max_fail = model.max_fail;
            
            
            
% % Changes the way the data is split
% model.net.divideFcn = 'divideind';
% model.net.divideParam.trainInd = 1:no_obs_train;
% model.net.divideParam.valInd = (no_obs_train+1):no_obs_total;
% model.net.divideParam.testInd = (no_obs_train+1):no_obs_total;


% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
