%                          X =
%              [X, flag_pca] =
% [X, flag_pca, flag_rotate] = ask_pca(X, flag_ask_rotate)
function [data, varargout] = ask_pca(data, flag_ask_rotate)

if ~exist('flag_ask_rotate', 'var')
    flag_ask_rotate = 1;
end;

flag = input('PCA first (0/1)? ');
flag_rotate = 0;
if flag == 1
    [dummy, loadings] = princomp2(data.X);
    no_factors = size(loadings, 2);
    
    what = ask_pca_factors(no_factors);
    
    loadings = loadings(:, what);

    if flag_ask_rotate
        while 1
            flag_rotate = input('Rotate PCA loadings (0/1)? ');
            
            if flag_rotate == 0 || flag_rotate == 1
                break;
            end;
        end;
        
        if flag_rotate
            loadings = rotatefactors2(loadings, 1);
        end;
    end;

    data.X = data_normalize(data.X, 'c')*loadings;
    data.x = 1:size(loadings, 2);
    data.loadings_pca = loadings;
end;

if nargout() > 1
    varargout(1) = {flag};
end;
if nargout() > 2
    varargout(2) = {flag_rotate};
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
