function bmresult_draw_lines(result, results)


SCALE = 1;

COLORS = colors3();
MARKER_MARKERS = 'do^v<>ph';

ytick = [];
yticklabel = {};

wn1 = results.x(1);
wn2 = results.x(end);

cnt = 1;
hh = [];
hhfrank = [];
legends = {};
for i = 1:length(result.lines)
    dl = results.drawlines(i);
    if dl.flag_line
        y1 = cy(dl.maxy, dl);
        y2 = cy(dl.miny, dl);
        
        box;
        plot([wn1, wn2, wn2, wn1, wn1], [y1, y1, y2, y2, y1], '-', 'Color', [1, 1 1]*0, 'LineWidth', 2*SCALE);
        hold on;
        plot([wn1, wn2], [1, 1]*y2, '-', 'Color', [1, 1 .1]*0, 'Linewidth', 2);
        if cnt < results.no_lines_eff
%             plot([wn1, wn2], [1, 1]*dl.axisylim(1), '-k', 'LineWidth', 2);
        end;
        
        ytick(end+1) = y1;
        yticklabel{end+1} = sprintf(result.lines(i).format, dl.maxy);
        
        plot(results.x, cy(result.lines(i).y, dl), 'Color', COLORS{i}, 'LineWidth', 3*SCALE);
        hold on;
        if result.lines(i).flag_zero_line
            plot([results.x(1), results.x(end)], [1, 1]*cy(0, dl), 'Color', COLORS{i}, 'LineWidth', 3*SCALE);
            ytick(end+1) = cy(0, dl);
            yticklabel{end+1} = '0';        
        end;
        if ~isempty(results.x(result.lines(i).peak_idxs))
            hh(end+1) = plot(results.x(result.lines(i).peak_idxs), cy(result.lines(i).y(result.lines(i).peak_idxs), dl), ...
                             'Color', COLORS{i}, 'Marker', MARKER_MARKERS(i), 'LineWidth', 3*SCALE, 'MarkerSize', 15*sqrt(SCALE), 'LineStyle', 'none' ...
                            );
            legends{end+1} = results.legends{i};
        end;
        
        cnt = cnt+1;

        
        ytick(end+1) = y2;
        yticklabel{end+1} = sprintf(result.lines(i).format, dl.miny);        
        
    end;
end;


% The joining lines
for i = 1:length(result.markers)
    marker = result.markers(i);
    for j = 1:length(marker.operands)-1
        op1 = marker.operands(j);
        op2 = marker.operands(j+1);
        plot([marker.xs(j), marker.xs(j+1)], [cy(marker.ys(j), results.drawlines(op1)), cy(marker.ys(j+1), results.drawlines(op2))], 'color', [.5, .5, .5], 'linewidth', 2*SCALE, 'linestyle', '--');
    end;
end;



% Fabricated the x ticks

%xtick = get(gca, 'XTick');
xtick = floor(wn1/100)*100:-100:ceil(wn2/100)*100;
for i = 1:length(xtick);
    if xtick(i)/200 == floor(xtick(i)/200)
        hhfrank(end+1) = text(xtick(i), -.05, format_number_with_commas(xtick(i)), 'HorizontalAlignment', 'center');
    end;
    for j = 1:length(result.lines)
        dl = results.drawlines(j);
        if dl.flag_line
            ymin = cy(dl.miny, dl);
            ymax = cy(dl.maxy, dl);
            EHEH_NEGO = .015;
            plot([1, 1]*xtick(i), ymin+[0, EHEH_NEGO], 'k', 'LineWidth', 2*SCALE);
            plot([1, 1]*xtick(i), ymax+[0, -EHEH_NEGO], 'k', 'LineWidth', 2*SCALE);
        end;
    end;
end;


% Now fabricates the y ticks


for i = 1:length(ytick)
    hhfrank(end+1) = text((wn1)+3, ytick(i), yticklabel{i}, 'HorizontalAlignment', 'right');
end;



%---------------
set(gca, 'YLim', [-0.005, 1.005]);
set(gca, 'XLim', [min(results.x)-1, max(results.x)+1]);
set(gca, 'XDir', 'reverse');
% set(gca, 'YTick', ytick(end:-1:1));
% set(gca, 'YTickLabel', yticklabel(end:-1:1));
legend(hh, legends);
format_frank(gcf, 1*SCALE, hhfrank);
axis off;



%----------------------------------------------------------------
function yout = cy(y, dl)
yout = (y-dl.miny)*dl.scale+dl.offset;

function drawbox(wnvector, ylim)

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
