% 
%
%  New biomarker analysis result
%
function o  = bmresult_draw_markers(o, flag_wntext)

if ~exist('flag_wntext')
    flag_wntext = 0;
end;



markers = o.markers




[no_methods, no_datasets] = size(xy);

markers = 'do^v<>ph';
colors = colors3();


if ~exist('names') || isempty(names)
    for i = 1:no_datasets
        names{i} = sprintf('Sequence %d', i);
    end;
end;



if ~exist('ds') || isempty(ds)
    wn1 = Inf;
    wn2 = -Inf;
    for i_method = 1:no_methods
        wn1 = min(wn1, min(wns{i_method}(:)));
        wn2 = max(wn2, max(wns(:)));
    end;
else
    wn1 = min(ds.x);
    wn2 = max(ds.x);
end;


hh = [];
hout = [];

xlim = [floor(round(wn1/50)*50/100)*100, ceil(round(wn2/50)*50/100)*100];

% Draw the vertical lines whichi will help identify the wavenumbers
if 1
    for x = ceil(wn1/50)*50:50:floor(wn2/50)*50
        
        % vertical line cannot overlap the "natural" matlab tick
        if x/100 == floor(x/100)
            uf = 0.17/8*no_datasets;
        else
            uf = 0.02/8*no_datasets;
        end;
        
        plot([x, x], [uf, no_datasets+1-uf], '--', 'LineWidth', 2, 'Color', .7*[1, 1, 1]);
        hold on;
    end;
end;



for i_method = 1:no_methods

    for i_dataset = 1:no_datasets
        x = xy(i_method, i_dataset).x;
        y = xy(i_method, i_dataset).y;
        
        no_markers = length(x);
        
        if isempty(y)
            y = linspace(1, .5, no_markers);
        end;
        
        ymax = max(y);
        ymin = min(y);

        height = i_dataset;
        
        
        if i_method == 1
            plot(xlim, height*[1, 1], 'k', 'LineWidth', 3);
            hold on;
            hh(end+1) = text(xlim(2)+5, height, names{i_dataset}, 'Interpreter', 'LaTeX', 'HorizontalAlignment', 'right');
        end;
    
        for i_marker = 1:no_markers
            TRINTA = 20;
            if no_markers == 1
                markersize = TRINTA;
            else
                markersize = ((y(i_marker)-ymin)/(ymax-ymin)+1)*TRINTA;
            end;
            htemp = plot(x(i_marker), height, 'LineStyle', 'none', 'Marker', markers(i_method), 'Color', colors{i_method}, ...
                'MarkerSize', markersize, 'LineWidth', 4); %, 'MarkerFaceColor', 'w');
            
            if i_dataset == 1 && i_marker == 1
                hout(end+1) = htemp; % for legends later
            end;
            
            if flag_wntext
                text(x(i_marker), height-.1, sprintf('%4.0f', x(i_marker)));
            end;
        end;
    end;

end;

set(gca, 'XTick', ceil(wn1/100)*100:100:floor(wn2/100)*100);
set(gca, 'XLim', xlim);
% set(gca, 'XGrid', 'on');
% set(gca, 'XMinorGrid', 'on');
% set(gca, 'XMinorTick', 'on');


set(gca, 'YTick', []); %1:no_datasets);
% set(gca, 'YTickLabel', []);
set(gca, 'YLim', [0, no_datasets+1]);
set(gca, 'XDir', 'reverse');
set(gca, 'YDir', 'reverse');

format_frank(gcf, 1, hh);
















--------------------------------------------


% function draw_markers(wns, names, intensities, ds, flag_wntext)
% 
% [no_datasets, no_methods] = size(xy);
%
%
function hout = draw_markers(xy, names, ds, flag_wntext)



% if ~exist('intensities') || isempty(intensities)
%     intensities = repmat(linspace(1, .5, no_markers), no_datasets, 1);
% end;


if ~exist('flag_wntext')
    flag_wntext = 0;
end;


[no_methods, no_datasets] = size(xy);

markers = 'do^v<>ph';
colors = colors3();


if ~exist('names') || isempty(names)
    for i = 1:no_datasets
        names{i} = sprintf('Sequence %d', i);
    end;
end;



if ~exist('ds') || isempty(ds)
    wn1 = Inf;
    wn2 = -Inf;
    for i_method = 1:no_methods
        wn1 = min(wn1, min(wns{i_method}(:)));
        wn2 = max(wn2, max(wns(:)));
    end;
else
    wn1 = min(ds.x);
    wn2 = max(ds.x);
end;


hh = [];
hout = [];

xlim = [floor(round(wn1/50)*50/100)*100, ceil(round(wn2/50)*50/100)*100];

% Draw the vertical lines whichi will help identify the wavenumbers
if 1
    for x = ceil(wn1/50)*50:50:floor(wn2/50)*50
        
        % vertical line cannot overlap the "natural" matlab tick
        if x/100 == floor(x/100)
            uf = 0.17/8*no_datasets;
        else
            uf = 0.02/8*no_datasets;
        end;
        
        plot([x, x], [uf, no_datasets+1-uf], '--', 'LineWidth', 2, 'Color', .7*[1, 1, 1]);
        hold on;
    end;
end;



for i_method = 1:no_methods

    for i_dataset = 1:no_datasets
        x = xy(i_method, i_dataset).x;
        y = xy(i_method, i_dataset).y;
        
        no_markers = length(x);
        
        if isempty(y)
            y = linspace(1, .5, no_markers);
        end;
        
        ymax = max(y);
        ymin = min(y);

        height = i_dataset;
        
        
        if i_method == 1
            plot(xlim, height*[1, 1], 'k', 'LineWidth', 3);
            hold on;
            hh(end+1) = text(xlim(2)+5, height, names{i_dataset}, 'Interpreter', 'LaTeX', 'HorizontalAlignment', 'right');
        end;
    
        for i_marker = 1:no_markers
            TRINTA = 20;
            if no_markers == 1
                markersize = TRINTA;
            else
                markersize = ((y(i_marker)-ymin)/(ymax-ymin)+1)*TRINTA;
            end;
            htemp = plot(x(i_marker), height, 'LineStyle', 'none', 'Marker', markers(i_method), 'Color', colors{i_method}, ...
                'MarkerSize', markersize, 'LineWidth', 4); %, 'MarkerFaceColor', 'w');
            
            if i_dataset == 1 && i_marker == 1
                hout(end+1) = htemp; % for legends later
            end;
            
            if flag_wntext
                text(x(i_marker), height-.1, sprintf('%4.0f', x(i_marker)));
            end;
        end;
    end;

end;

set(gca, 'XTick', ceil(wn1/100)*100:100:floor(wn2/100)*100);
set(gca, 'XLim', xlim);
% set(gca, 'XGrid', 'on');
% set(gca, 'XMinorGrid', 'on');
% set(gca, 'XMinorTick', 'on');


set(gca, 'YTick', []); %1:no_datasets);
% set(gca, 'YTickLabel', []);
set(gca, 'YLim', [0, no_datasets+1]);
set(gca, 'XDir', 'reverse');
set(gca, 'YDir', 'reverse');

format_frank(gcf, 1, hh);

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
