% function bmresult = bmresult_go_sfs(bmresult, ds, ms, sfs_k, sfs_max_vars)
%
% Performs a stepwise feature selection as a means to derive biomarkers
%
function bmresult = bmresult_go_sfs(bmresult, ds, ms, sfs_k, sfs_max_vars)


o = feasel_new();
o.ms = ms;
o.no_reps = sfs_k;
o.min_vars = 1;
o.max_vars = sfs_max_vars;
o.flag_forward = 1;
o.ds = ds;
o = feasel_go_stepwise(o);

for j = 1:length(o.logs)
    logg = o.logs(j);
    bmresult.sfs_best_rates(j) = mean(logg.cases(logg.idx_best).performances);
end;
bmresult.sfs_idxs_best_final = o.logs(end).cases(o.logs(end).idx_best).idxs;
bmresult.sfs_evolution = feasel_curves_from_cases(o);


% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
