% function o = bmresultline_build_mountain(o)
%
% peaks must be alreay built built
function o = bmresultline_build_mountain(o, no_markers)

nf = length(o.y);

if nf > 0
    if o.peak_flag_abs
        y_grab = abs(o.y);
    else
        y_grab = o.y;
    end;
    
    if o.peak_flag_span
        span = max(y_grab)-min(y_grab);
    else
        span = max(y_grab);
    end;
    
    peakidxs = detect_peaks2(y_grab, o.peak_threshold, o.peak_min_distance, no_markers, o.peak_min_height_perc*span, o.peak_no_convolutions);
    
    o.peak_idxs = peakidxs;
    
    
    % These variables in the future can be part of some global setup
    MOUNTAIN_WIDTH = 7;
    HEIGHT_AT = .5;
    s = -MOUNTAIN_WIDTH^2/log(HEIGHT_AT);
    mountains = zeros(1, nf);
    for i = 1:length(o.peak_idxs)
        mountains = max(mountains, exp(-((1:nf)-o.peak_idxs(i)).^2/s));
        o.mountains_y = mountains;
    end;
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
