function o = bmresults_calculate_drawlines(o)

if length(o.items) == 0
    return;
end;

no_lines = length(o.items(1).lines);
no_lines_eff = 0;

for i = 1:no_lines
    maxy = -Inf;
    miny = Inf;
    for j = 1:length(o.items)
      maxy = max(maxy, max(o.items(j).lines(i).y));
      miny = min(miny, min(o.items(j).lines(i).y));
      
    end;
    
    temp(i).axisylim = [];
    temp(i).offset = 0;
    temp(i).scale = 0;
    temp(i).flag_line = 0;
    if maxy ~= -Inf
        no_lines_eff = no_lines_eff+1;
        temp(i).maxy = maxy;
        temp(i).miny = miny;
        temp(i).flag_line = 1;
    end;
end;

o.drawlines = temp;


FRAMEPERC = .85;

if no_lines_eff > 1
    spacing = (1-FRAMEPERC)/(no_lines_eff-1);
else
    spacing = 0;
end;

height = FRAMEPERC/no_lines_eff;

ypos = 0;
    
for i = no_lines_eff:-1:1
    o.drawlines(i).scale = 1/(o.drawlines(i).maxy-o.drawlines(i).miny)*FRAMEPERC/no_lines_eff;
    o.drawlines(i).offset = ypos;
    
    if i == no_lines_eff
        a1 = 0;
    else
        a1 = spacing/2;
    end;
    if i == 1
        a2 = 0;
    else
        a2 = spacing/2;
    end;
    o.drawlines(i).axisylim = [ypos-a1, ypos+height+a2];
    
    ypos = ypos+height+spacing;
end;

o.no_lines_eff = no_lines_eff;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
