function varargout = bmtool(varargin)
% BMTOOL M-file for bmtool.fig
%      BMTOOL, by itself, creates a new BMTOOL or raises the existing
%      singleton*.
%
%      H = BMTOOL returns the handle to a new BMTOOL or the handle to
%      the existing singleton*.
%
%      BMTOOL('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in BMTOOL.M with the given input arguments.
%
%      BMTOOL('Property','Value',...) creates a new BMTOOL or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before bmtool_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to bmtool_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help bmtool

% Last Modified by GUIDE v2.5 09-Feb-2010 16:43:00

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @bmtool_OpeningFcn, ...
                   'gui_OutputFcn',  @bmtool_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before bmtool is made visible.
function bmtool_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to bmtool (see VARARGIN)

% Choose default command line output for bmtool
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% UIWAIT makes bmtool wait for user response (see UIRESUME)
% uiwait(handles.figure1);

colors_markers();

global handles_bmtool;
handles_bmtool = handles;

refresh_ds();
refresh_dsmounted();
refresh_dsmounted_selected();
refresh_results();
refresh_results_selected();
gui_set_position(hObject);











% --- Outputs from this function are returned to the command line.
function varargout = bmtool_OutputFcn(hObject, eventdata, handles) 
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;





%##########################################################################
%##########################################################################


%#########
function refresh_ds()
global handles_bmtool;
vars = evalin('base', 'who(''ds*'')');
if isempty(vars)
    vars = {'(None)'};
    a = vars;
else
    a = vars;
    for i = 1:length(a)
        ds = evalin('base', vars{i});
        no_levels = sum(ds.class_labels{1} == '|')+1;
        no_classes = length(ds.class_labels);
        a{i} = [a{i} sprintf(' (classes: %d; levels: %d)', no_classes, no_levels)];
    end;
end;
if get(handles_bmtool.popupmenuDS, 'Value') > length(vars)
    set(handles_bmtool.popupmenuDS, 'Value', 1);
end;
set(handles_bmtool.popupmenuDS, 'String', a);
set(handles_bmtool.popupmenuDS, 'UserData', vars);



%#########


function refresh_dsmounted()
global handles_bmtool;
flag_none = 0;
try
    datasets = evalin('base', 'bmtool_datasets');
catch ME
    flag_none = 1;
end;
a = {};

if ~flag_none
    for i = 1:length(datasets)
        a{end+1} = sprintf('%s (classes: %d)', datasets(i).name, length(datasets(i).data.class_labels));
    end;
end;
set(handles_bmtool.listboxDatasets, 'Value', 1);
set(handles_bmtool.listboxDatasets, 'String', a);


%#########


function refresh_dsmounted_selected()

global handles_bmtool;
hObject = handles_bmtool.listboxDatasets;

idxs = get(hObject, 'Value');
a = get(hObject, 'String');
if length(a) == 0
    s = '0';
elseif length(a) == length(idxs)
    s = 'All';
else
    s = int2str(length(idxs));
end;
set(handles_bmtool.textSelected, 'String', sprintf('%s selected', s));


%#########


function refresh_results()
global handles_bmtool;
flag_none = 0;
try
    results = evalin('base', 'bmtool_results');
catch ME
    flag_none = 1;
end;
a = {};

if ~flag_none
    for i = 1:length(results.items)
        
        temp = results.items(i);
        s = '';
        
        if ~isempty(temp.lines(1).y)
            if ~isempty(s); s = [s ', ']; end;
            s = [s 'BM1'];
        end;
        if ~isempty(temp.lines(2).y)
            if ~isempty(s); s = [s ', ']; end;
            s = [s 'BM2'];
        end;
        if ~isempty(temp.bm2_surface);
            if ~isempty(s); s = [s ', ']; end;
            s = [s 'BM2 surface'];
        end;
        if ~isempty(temp.lines(3).y);
            if ~isempty(s); s = [s ', ']; end;
            s = [s 'BM3'];
        end;
        if ~isempty(temp.sfs_best_rates);
            if ~isempty(s); s = [s ', ']; end;
            s = [s 'SFS'];
        end;
        
        if isempty(s); s = '(nothing stored)'; end;
        a{end+1} = [temp.name ': ' s];
    end;
end;
set(handles_bmtool.listboxResults, 'Value', 1);
set(handles_bmtool.listboxResults, 'String', a);


%#########


function refresh_results_selected()

global handles_bmtool;
hObject = handles_bmtool.listboxResults;

idxs = get(hObject, 'Value');
a = get(hObject, 'String');
if length(a) == 0
    s = '0';
elseif length(a) == length(idxs)
    s = 'All';
else
    s = int2str(length(idxs));
end;
set(handles_bmtool.textResultsSelected, 'String', sprintf('%s selected', s));



%#########




% function eval_code(s, flag_add = 0, flag_refresh = 0)
%
% flag_add: adds to editCode as well?
% flag_refresh: refreshed model listbox? 
function eval_code(s, flag_add, flag_refresh)

global handles_bmtool;


if ~exist('flag_add', 'var')
    flag_add = 0;
end;
if ~exist('flag_refresh', 'var')
    flag_refresh = 0;
end;

try
    evalin('base', s);

    if flag_add
        hObject = handles_bmtool.editCode;
        code = get(hObject, 'String');
        code{end+1} = s;
        set(hObject, 'String', code);
    end;
    
    if flag_refresh
        refresh_ds();
    end;

catch ME
    msgbox(ME.message, 'Error!');
    rethrow(ME)
end;

function name_new = find_name(prefix)
i = 1;
while 1
    name_new = sprintf('%s%02d', prefix, i);
%         keyboard;
    if ~evalin('base', sprintf('exist(''%s'', ''var'')', name_new))
        break;
    end;
    i = i+1;
end;

function add_code(s)
global handles_bmtool;
hObject = handles_bmtool.editCode;
code = get(hObject, 'String');
code{end+1} = s;
set(hObject, 'String', code);


%##########################################################################


%*%*%*%*%*%*%*%*%*%*%*%*%*%*%*%


% --- Executes on button press in pushbuttonLoadDS.
function pushbuttonLoadDS_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonLoadDS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

try
    atrtool_load();
    
    global ATRTOOL_LOAD_NAME ATRTOOL_LOAD_TYPE ATRTOOL_LOAD_RANGE;
    
    if ~isempty(ATRTOOL_LOAD_NAME)

         name_new = find_name('ds');
         
         s_range = '';
         if ~isempty(ATRTOOL_LOAD_RANGE)
             s_range = [', ' mat2str(ATRTOOL_LOAD_RANGE)];
         end;
         
         code = sprintf('load_%s_file(''%s''%s);\nglobal DATA;\n%s = DATA;', ...
             ATRTOOL_LOAD_TYPE, ATRTOOL_LOAD_NAME, s_range, name_new);
         
         eval_code(code);
         add_code(code);

         refresh_ds();
    end;
        
catch ME
    msgbox(ME.message, 'Error!');
    rethrow(ME)
end;



%*%*%*%*%*%*%*%*%*%*%*%*%*%*%*%



% --- Executes on button press in pushbuttonRefreshDS.
function pushbuttonRefreshDS_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonRefreshDS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
refresh_ds();


%*%*%*%*%*%*%*%*%*%*%*%*%*%*%*%



% --- Executes on button press in pushbuttonMount.
function pushbuttonMount_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonMount (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



T_ERROR = 0;
T_HIERARCHICAL = 1;
T_AGENT = 2;

type = T_ERROR;
s_error = '';

try
    % Checks if parameters are filled properly.
    % Validation is not exhaustive and does not include valid range check. If numbers are outside level or class rance,
    % errors will occur later.

    
    % Gets dataset variable name
    a = get(handles.popupmenuDS, 'UserData');
    if ~isempty(a)
        ds_name = a{get(handles.popupmenuDS, 'Value')};
        if strcmp(ds_name, '(None)')
            ds_name = '';
        end;
    end;

    flag_ok = 1;
    if isempty(ds_name)
        s_error = 'No input dataset was selected!';
        flag_ok = 0;
    end;

    
    if flag_ok
        if get(handles.radiobuttonHierarchical, 'Value')
            levels_main = eval(get(handles.editMainLevels, 'String'));
            if isempty(levels_main) 
                s_error = 'Please specify the main level(s)!';
            elseif ~isnumeric(levels_main)
                s_error = 'Main level(s) must be a vector of integers!';
            else
                type = T_HIERARCHICAL;
            end;
        elseif get(handles.radiobuttonAgentVC, 'Value')
            idx_vc = eval(get(handles.editVCIndex, 'String'));
            if isempty(idx_vc)
                s_error = 'Please specify the VC class index!';
            elseif ~isnumeric(idx_vc) || length(idx_vc) > 1
                s_error = 'VC class index must be an integer value!';
            else
                type = T_AGENT;
            end;
        end;
    end;
    
catch ME
    msgbox(ME.message, 'Error!');
    rethrow(ME)
end;

flag_ok = 1;
if type == T_ERROR
    msgbox(s_error, 'Error!');
    flag_ok = 0;
elseif type == T_HIERARCHICAL
    s_code = sprintf([ ...
'dwork = %s;\n' ...
'levels_main = %s;\n' ...
'clear bmtool_datasets;\n' ...
'pieces = data_split_classes(dwork, levels_main);\n' ...
'for i = 1:length(pieces)\n' ...
'    bmtool_datasets(i).data = pieces(i);\n' ...
'    dtemp = data_select_hierarchy(bmtool_datasets(i).data, levels_main);\n' ...
'    bmtool_datasets(i).name =  dtemp.class_labels{1};\n' ...
'end;\n' ...
'clear pieces dtemp dwork;\n'], ...
ds_name, mat2str(levels_main));
elseif type == T_AGENT
    s_code = sprintf([ ...
'\n%% --- BMTOOL analysis dataset mounting: treatment vs. vehicle control ---\n' ...
'dwork = %s;\n' ...
'idx_vc = %d;\n' ...
'pieces = data_split_classes(dwork);\n' ...
'ii = 0;\n' ...
'clear bmtool_datasets;\n' ...
'for i = 1:length(pieces)\n' ...
'    if i ~= idx_vc\n' ...
'        ii = ii+1;\n' ...
'        bmtool_datasets(ii).data = data_merge(pieces([idx_vc, i]));\n' ...
'        bmtool_datasets(ii).name = [pieces(i).class_labels{1} '' vs. '' pieces(idx_vc).class_labels{1}];\n' ...
'    end;\n' ...
'end;\n' ...
'    clear pieces dwork;\n'], ...
ds_name, idx_vc);

end;


if flag_ok == 1;
    eval_code(s_code, 1, 0);
    refresh_dsmounted();
end;



%*%*%*%*%*%*%*%*%*%*%*%*%*%*%*%


% --- Executes on button press in pushbuttonSelectAllDatasets.
function pushbuttonSelectAllDatasets_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonSelectAllDatasets (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global handles_bmtool;
hObject = handles_bmtool.listboxDatasets;

a = get(hObject, 'String');
set(hObject, 'Value', 1:length(a));

refresh_dsmounted_selected();



%*%*%*%*%*%*%*%*%*%*%*%*%*%*%*%



% --- Executes on button press in pushbuttonRun.
function pushbuttonRun_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonRun (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

flag_bm1 = get(handles.checkboxBM1, 'Value');
flag_bm2 = get(handles.checkboxBM2, 'Value');
flag_bm3 = get(handles.checkboxBM3, 'Value');
flag_sfs = get(handles.checkboxSFS, 'Value');

s_error = '';
flag_params = 0;
try
    % Checks if parameters are filled properly.
    % Validation is not exhaustive and does not include valid range check. If numbers are outside level or class rance,
    % errors will occur later.

    while 1

        if flag_bm2
            temp = get(handles.popupmenuBM2NoVars, 'String');
            bm2_no_vars = eval(temp{get(handles.popupmenuBM2NoVars, 'Value')});

            bm2_k = eval(get(handles.editBM2k, 'String'));
            if isempty(bm2_k)
                s_error = 'Please inform BM2 k!';
                break;
            end;
        end;

        if flag_bm3
            bm3_max_vars = eval(get(handles.editBM3MaxVars, 'String'));
            if isempty(bm3_max_vars)
                s_error = 'Please inform BM3 top number of variables!';
                break;
            end;
            bm3_no_reps = eval(get(handles.editBM3NoReps, 'String'));
            if isempty(bm3_no_reps)
                s_error = 'Please inform BM3 number of bootstraps!';
                break;
            end;
        end;

        if flag_sfs
            sfs_max_vars = eval(get(handles.editSFSMaxVars, 'String'));
            if isempty(sfs_max_vars)
                s_error = 'Please inform SFS top number of variables!';
                break;
            end;
            sfs_k = eval(get(handles.editSFSk, 'String'));
            if isempty(sfs_k)
                s_error = 'Please inform SFS k!';
                break;
            end;
        end;    



        datasets = evalin('base', 'bmtool_datasets');
        flag_outtahere = 0;
        for i = 1:length(datasets)
            if flag_bm1
                if length(datasets(i).data.class_labels) ~= 2
                    s_error = sprintf('BM1 needs 2-class datasets, but dataset #%d has %d!', i, length(datasets(i).data.class_labels));
                    flag_outtahere = 1;
                end;
            end;
            
            if flag_bm2 || flag_bm3 || flag_sfs
                if length(datasets(i).data.class_labels) < 2
                    s_error = sprintf('Datasets need to have at least 2 classes, but daset #%d has only %d!', i, length(datasets(i).data.class_labels));
                    flag_outtahere = 1;
                end;
            end;
        end;
        if flag_outtahere
            break;
        end;
    
        idxs_selected = get(handles.listboxDatasets, 'Value');
        flag_params = 1;
        break;
    end;

catch ME
    msgbox(ME.message, 'Error!');
    rethrow(ME)
end;

if ~flag_params
    msgbox(s_error, 'Error!');
    return;
end;


s_code = sprintf('\n');

if flag_bm2    
    s_code = [s_code sprintf(['bm2_no_vars = ' int2str(bm2_no_vars) ';\nbm2_k = ' int2str(bm2_k) ';\n'])];
end;
if flag_bm3
    s_code = [s_code sprintf(['bm3_max_vars = ' int2str(bm3_max_vars) ';\nbm3_no_reps = ' int2str(bm3_no_reps) ';\n'])];
end;

if flag_sfs
    s_code = [s_code sprintf(['sfs_max_vars = ' int2str(sfs_max_vars) ';\nsfs_k = ' int2str(sfs_k) ';\n'])];
end;






s_code = [s_code sprintf([ ...
'\n%% --- BMTOOL results generation ---\n' ...
'clear bmtool_results;\n' ...
'datasets = bmtool_datasets(' mat2str(idxs_selected) ');\n' ...
'no_datasets = length(datasets);\n' ...
'bmtool_results = bmresults_new();\n' ...
'bmtool_results.indicator_y = mean(bmtool_datasets(1).data.X);\n' ...
'bmtool_results.x = bmtool_datasets(1).data.x;\n' ...       
'bmtool_results.legends = {''BM1'', ''BM2'', ''BM3''};\n' ...
'for i = 1:no_datasets\n' ...
'    bmtool_results.items(i) = bmresult_new();\n' ...
'    bmtool_results.items(i).lines = repmat(bmresultline_new(), 1, 3);\n' ...
'    bmtool_results.items(i).name = bmtool_datasets(i).name;\n' ...
'    bmtool_results.items(i).x = bmtool_results.x;\n' ...
'\n' ...
'    o = bmresultline_new();\n' ...
'    bmtool_results.items(i).lines(1) = o;\n' ...
'    bmtool_results.items(i).lines(2) = o;\n' ...
'    bmtool_results.items(i).lines(3) = o;\n' ...
])];


if flag_bm2 || flag_bm3 || flag_sfs
    s_code = [s_code sprintf([ ...
'    modelset01 = modelset_new(@cla_new, 0);\n' ...
'    modelset01 = modelset_create_models(modelset01, bmtool_datasets(i).data);\n' ...
'    modelset01 = modelset_setbatch(modelset01, {''type'', ''linear'', ''flag_class2mo'', 1});\n' ...
])];
end;


if flag_bm1
    s_code = [s_code sprintf([...
'\n' ...
'    %%------\n' ...
'    %% BM1\n' ...
'    %%-----\n' ...
'    pieces = data_split_classes(bmtool_datasets(i).data);\n' ...
'    bmtool_results.items(i).lines(1).y = mean(pieces(2).X)-mean(pieces(1).X);\n' ...
])];
end;
    
if flag_bm2    
    s_code = [s_code sprintf([ ...
'\n' ...
'    %%------n' ...
'    %% BM2\n' ...
'    %%------n' ...
'    modelset01 = modelset_boot(modelset01, bmtool_datasets(1).data);\n' ...
'    o = feasel_new();\n' ...
'    o.ms = modelset01;\n' ...
'    o.no_reps = bm2_k;\n' ...
'    o.flag_forward = 0;\n' ...
'    o.ds = bmtool_datasets(i).data;\n' ...
])];

    if bm2_no_vars == 1
        s_code = [s_code sprintf([ ...
'    o = feasel_go_exhaustive(o, 1);\n' ...
'    bmtool_results.items(i).lines(2).y = feasel_get_features_ranking(o)*100;\n' ...
])];
    else
        s_code = [s_code sprintf([ ...
'    o = feasel_go_exhaustive2(o);\n' ...
'    bmtool_results.items(i).bm2_surface = feasel_get_performance_matrix(o);\n' ...
])];
    end;
end;

if flag_bm3
    s_code = [s_code sprintf([ ...
'\n' ...
'    %%------\n' ...
'    %% BM3\n' ...
'    %%------\n' ...
'    bmtool_results.items(i).lines(3).y = build_bm3_histogram(bmtool_datasets(i).data, modelset01, bm3_max_vars, 0.9, bm3_no_reps);\n' ...
])];
end;

if flag_sfs
    s_code = [s_code sprintf([ ...
'\n' ...
'    %%------n' ...
'    %% SFS\n' ...
'    %%------n' ...
'    o = feasel_new();\n' ...
'    o.ms = modelset01;\n' ...
'    o.no_reps = sfs_k;\n' ...
'    o.min_vars = 1;\n' ...
'    o.max_vars = sfs_max_vars;\n' ...
'    o.flag_forward = 1;\n' ...
'    o.ds = bmtool_datasets(i).data;\n' ...
'    o = feasel_go_stepwise(o);\n' ...
'\n' ...
'    for j = 1:length(o.logs)\n' ...
'        logg = o.logs(j);\n' ...
'        bmtool_results.items(i).sfs_best_rates(j) = mean(logg.cases(logg.idx_best).performances);\n' ...
'    end;\n' ...
'    bmtool_results.items(i).sfs_idxs_best_final = o.logs(end).cases(o.logs(end).idx_best).idxs;\n' ...
'    bmtool_results.items(i).sfs_evolution = feasel_curves_from_cases(o);\n' ...
])];
end;


s_code = [s_code sprintf([ ...
'end\n'
])];


eval_code(s_code, 1);
refresh_results();


%*%*%*%*%*%*%*%*%*%*%*%*%*%*%*%


% --- Executes on button press in pushbuttonSelectAllResults.
function pushbuttonSelectAllResults_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonSelectAllResults (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global handles_bmtool;
hObject = handles_bmtool.listboxResults;

a = get(hObject, 'String');
set(hObject, 'Value', 1:length(a));


refresh_results_selected();


%*%*%*%*%*%*%*%*%*%*%*%*%*%*%*%


% --- Executes on button press in pushbuttonVisualize.
function pushbuttonVisualize_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonVisualize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


s_error = 0;

try
    results = evalin('base', 'bmtool_results');
catch ME
    s_error = 'No results stored!', 'Error!';
end;

if ~s_error
    option = get(handles.popupmenuVisualize, 'Value');
    idxs_selected = get(handles.listboxResults, 'Value');

    if length(idxs_selected) == 0
        s_error = 'Please select at least one result!';
    end;
end;


while 1
    if s_error
        break;
    end;
    
    s_code = '';

    if option == 1
        % Difference between means curves

        if isempty(results.items(idxs_selected(1)).lines(1).y)
            s_error = 'No BM1 curve stored in results!';
            break;
        end;
        
        s_code = [s_code sprintf([ ...
'\n%% Visualization: BM1 curves\n' ...
'results = bmtool_results;\n' ...
'results.items = bmtool_results.items(' mat2str(idxs_selected) ');\n' ...
'figure;\n' ...
'legends = {};\n' ...
'hh = [];\n' ...
'draw_zero_line(results.x);\n' ...
'hold on;\n' ...
'plot_indicator_spectrum(results.x, results.indicator_y/max(results.indicator_y)*.08);\n' ...
'for i = 1:length(results.items)\n' ...
'    hh(end+1) = plot(results.x, results.items(i).lines(1).y, ''Color'', find_color(i), ''LineWidth'', 3);\n' ...
'    legends{end+1} = [results.items(i).name];\n' ...
'end;\n' ...
'legend(hh, legends);\n' ...
'format_wn(results.x);\n' ...
'format_frank(gcf);\n' ...
'title(''BM1: Differences-between-means curves'');\n' ...
'clear results legends hh;\n' ...
])];

    elseif option == 2
        % Classification rate curve

        if isempty(results.items(idxs_selected(1)).lines(2).y)
            s_error = 'No BM2 curve stored in results!';
            break;
        end;


        s_code = [s_code sprintf([ ...
'\n%% Visualization: BM2 curves\n' ...
'results = bmtool_results;\n' ...
'results.items = bmtool_results.items(' mat2str(idxs_selected) ');\n' ...
'figure;\n' ...
'legends = {};\n' ...
'hh = [];\n' ...
'draw_zero_line(results.x);\n' ...
'hold on;\n' ...
'plot_indicator_spectrum(results.x, results.indicator_y/max(results.indicator_y)*80);\n' ...
'for i = 1:length(results.items)\n' ...
'    hh(end+1) = plot(results.x, results.items(i).lines(2).y, ''Color'', find_color(i), ''LineWidth'', 3);\n' ...
'    legends{end+1} = [results.items(i).name];\n' ...
'end;\n' ...
'legend(hh, legends);\n' ...
'ylabel(''Classification rate (%%)'');\n' ...
'format_wn(results.x);\n' ...
'format_frank(gcf);\n' ...
'title(''BM2: Classification rates curves'');\n' ...
'clear results legends hh;\n' ...
])];


    elseif option == 3
        % Classification rate surface

        if isempty(results.items(idxs_selected(1)).bm2_surface)
            s_error = 'No BM2 classification surface stored in the results!';
            break;
        end;

        s_code = [s_code sprintf([ ...
'\n%% Visualization: BM2 surface\n' ...
'result = bmtool_results.items(' int2str(idxs_selected(1)) ');\n' ...
'figure;\n' ...
'draw_covariance(result.bm2_surface*100, bmtool_results.x, bmtool_results.indicator_y);\n' ...
'title([result.name]);\n' ...
'colorbar;\n' ...
'format_frank(gcf);\n' ...
'clear result;\n' ...
])];

    elseif option == 4

        if isempty(results.items(idxs_selected(1)).lines(3).y)
            s_error = 'No BM3 histogram stored in results!';
            break;
        end;

        
        s_code = [s_code sprintf([ ...
'\n%% Visualization: BM3 histogram\n' ...
'result = bmtool_results.items(' int2str(idxs_selected(1)) ');\n' ...
'figure;\n' ...
'plot(bmtool_results.x, result.lines(3).y);\n' ...
'title([result.name]);\n' ...
'format_wn;\n' ...
'ylabel(''Hit count'');\n' ...
'format_frank;\n' ...
])];

    elseif option == 5                
        % Plots the classification rate versus the number of wavenumbers

        
        if isempty(results.items(idxs_selected(1)).sfs_best_rates)
            s_error = 'No stepwise feature selection stored in results!';
            break;
        end;

        
            s_code = [s_code sprintf([ ...
'\n%% Visualization: [no wavenumbers]x[classification rate]\n' ...
'results = bmtool_results;\n' ...
'results.items = bmtool_results.items(' mat2str(idxs_selected) ');\n' ...
'figure;\n' ...
'hh = [];\n' ...
'for i = 1:length(results.items)\n' ...
'    hh(i) = plot(results.items(i).sfs_best_rates*100, ''LineWidth'', 5, ''Color'', find_color(i));\n' ...
'    hold on;\n' ...
'end;\n' ...
'xlabel(''Number of variables'');\n' ...
'ylabel(''Classification rate (%%)'');\n' ...
'legend(hh, {results.items.name});\n' ...
'format_frank(gcf);\n' ...
])];

    elseif option == 6
        % Evolution

        
        if isempty(results.items(idxs_selected(1)).sfs_evolution)
            s_error = 'No stepwise feature selection stored in the results!';
            break;
        end;

        
        s_code = [s_code sprintf([ ...
'\n%% Visualization: stepwise feature selection evolution\n' ...
'result = bmtool_results.items(' int2str(idxs_selected(1)) ');\n' ...
'curves = result.sfs_evolution;\n' ...
'np = length(curves);\n' ...
'figure;\n' ...
'for i = 1:np\n' ...
'    subplot(np, 1, i);\n' ...
'    x = result.x(curves(i).idx);\n' ...
'    y = curves(i).performance;\n' ...
'    plot_curve_pieces(x, y);\n' ...
'    [va, in] = max(y);\n' ...
'    hold on;\n' ...
'    plot(x(in), y(in), ''rx'');\n' ...
'    set(gca, ''XDir'', ''reverse'');\n' ...
'    if i == 1\n' ...
'        title(''None before'');\n' ...
'    else\n' ...
'        wn = bmtool_results.x(result.sfs_idxs_best_final(i-1));\n' ...
'        title(sprintf(''%%4.0f added'', wn));\n' ...
'    end;\n' ...
'end;\n' ...
'clear curves np x y;\n' ...
])];

    elseif option == 7
    % ^^^^  (o) ^ (o)  ^^^^ -------------- biomarker balls
   
        s_code = [s_code sprintf([ ...
'\n%% ^^^^  (o)v(o)  ^^^^  biomarker-localization plots\n' ...
'bmtool_results = bmtool_setuplines(bmtool_results);\n' ...
'figure;\n' ...
'no_markers = 5;\n' ...
'for i = 1:length(bmtool_results.items)\n' ...
'    bmtool_results.items(i) = bmresult_intersect(bmtool_results.items(i), no_markers);\n' ...
'end;\n' ...
'bmresults_draw_markers(bmtool_results, 0);\n' ...
'clear no_markers;\n' ...
])];
    
    elseif option == 8
        s_code = [s_code sprintf([ ...
'\n%% ^^^^  (o)v(o)  ^^^^  DP curves with connection lines\n' ...
'bmtool_results = bmtool_setuplines(bmtool_results);\n' ...
'result = bmtool_results.items(' int2str(idxs_selected(1)) ');\n' ...
'figure;\n' ...
'result = bmresult_intersect(result, 5);\n' ...
'bmtool_results = bmresults_calculate_drawlines(bmtool_results);\n' ...
'bmresult_draw_lines(result, bmtool_results);\n' ...
'title(result.name);\n' ...
])];
    elseif option == 9
        s_code = [s_code sprintf([ ...
'\n%% Biomarker localization report\n' ...
'results = bmtool_results;\n' ...
'results.items = bmtool_results.items(' mat2str(idxs_selected) ');\n' ...
'results = bmtool_setuplines(results);\n' ...
'for i = 1:length(results.items)\n' ...
'    results.items(i) = bmresult_intersect(results.items(i), 5);\n' ...
'    fprintf(''\\n * %%s *\\n\\n'', results.items(i).name);\n' ...
'    fprintf(bmresult_intersection_report(results.items(i)));\n' ...
'end;\n' ...
])];

    end;

    break;
end;

if s_error
	msgbox(s_error, 'Error!');
else
    eval_code(s_code, 1);
end;




% --- Executes on selection change in listboxResults.
function listboxResults_Callback(hObject, eventdata, handles)
% hObject    handle to listboxResults (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listboxResults contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listboxResults
refresh_results_selected();


% --- Executes on selection change in popupmenuDS.
function popupmenuDS_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuDS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenuDS contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuDS




% --- Executes during object creation, after setting all properties.
function popupmenuDS_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuDS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in radiobuttonMultiple.
function radiobuttonMultiple_Callback(hObject, eventdata, handles)
% hObject    handle to radiobuttonMultiple (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobuttonMultiple


% --- Executes on button press in radiobuttonSingle.
function radiobuttonSingle_Callback(hObject, eventdata, handles)
% hObject    handle to radiobuttonSingle (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radiobuttonSingle

% --- Executes on button press in pushbuttonCreate.
function pushbuttonCreate_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonCreate (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)



suffixes = {'frbm', 'lin', 'cla', 'dist', 'knn', 'ann', 'svm', 'mnr'};
which = get(handles.popupmenuAlgorithm, 'Value');

eval(['clastool_' suffixes{which} '();']);



% --- Executes on selection change in popupmenuAlgorithm.
function popupmenuAlgorithm_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuAlgorithm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenuAlgorithm contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuAlgorithm


% --- Executes during object creation, after setting all properties.
function popupmenuAlgorithm_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuAlgorithm (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenuPreProcess.
function popupmenuPreProcess_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuPreProcess (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenuPreProcess contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuPreProcess


% --- Executes during object creation, after setting all properties.
function popupmenuPreProcess_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuPreProcess (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenuTransform.
function popupmenuTransform_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuTransform (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenuTransform contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuTransform


% --- Executes during object creation, after setting all properties.
function popupmenuTransform_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuTransform (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editMaxVars_Callback(hObject, eventdata, handles)
% hObject    handle to editMaxVars (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editMaxVars as text
%        str2double(get(hObject,'String')) returns contents of editMaxVars as a double


% --- Executes during object creation, after setting all properties.
function editMaxVars_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editMaxVars (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editPenalty_Callback(hObject, eventdata, handles)
% hObject    handle to editPenalty (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editPenalty as text
%        str2double(get(hObject,'String')) returns contents of editPenalty as a double


% --- Executes during object creation, after setting all properties.
function editPenalty_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editPenalty (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editMainLevels_Callback(hObject, eventdata, handles)
% hObject    handle to editMainLevels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editMainLevels as text
%        str2double(get(hObject,'String')) returns contents of editMainLevels as a double


% --- Executes during object creation, after setting all properties.
function editMainLevels_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editMainLevels (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editVCIndex_Callback(hObject, eventdata, handles)
% hObject    handle to editVCIndex (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editVCIndex as text
%        str2double(get(hObject,'String')) returns contents of editVCIndex as a double


% --- Executes during object creation, after setting all properties.
function editVCIndex_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editVCIndex (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on selection change in listboxDatasets.
function listboxDatasets_Callback(hObject, eventdata, handles)
% hObject    handle to listboxDatasets (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listboxDatasets contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listboxDatasets

refresh_dsmounted_selected();


% --- Executes during object creation, after setting all properties.
function listboxDatasets_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listboxDatasets (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkboxBM1.
function checkboxBM1_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxBM1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxBM1


% --- Executes on button press in checkboxBM2.
function checkboxBM2_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxBM2 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxBM2


% --- Executes on button press in checkboxBM3.
function checkboxBM3_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxBM3 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxBM3



function edit17_Callback(hObject, eventdata, handles)
% hObject    handle to edit17 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of edit17 as text
%        str2double(get(hObject,'String')) returns contents of edit17 as a double


% --- Executes during object creation, after setting all properties.
function edit17_CreateFcn(hObject, eventdata, handles)
% hObject    handle to edit17 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on selection change in popupmenuBM2NoVars.
function popupmenuBM2NoVars_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuBM2NoVars (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenuBM2NoVars contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuBM2NoVars


% --- Executes during object creation, after setting all properties.
function popupmenuBM2NoVars_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuBM2NoVars (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editBM2k_Callback(hObject, eventdata, handles)
% hObject    handle to editBM2k (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editBM2k as text
%        str2double(get(hObject,'String')) returns contents of editBM2k as a double


% --- Executes during object creation, after setting all properties.
function editBM2k_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editBM2k (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editBM3MaxVars_Callback(hObject, eventdata, handles)
% hObject    handle to editBM3MaxVars (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editBM3MaxVars as text
%        str2double(get(hObject,'String')) returns contents of editBM3MaxVars as a double


% --- Executes during object creation, after setting all properties.
function editBM3MaxVars_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editBM3MaxVars (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editBM3NoReps_Callback(hObject, eventdata, handles)
% hObject    handle to editBM3NoReps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editBM3NoReps as text
%        str2double(get(hObject,'String')) returns contents of editBM3NoReps as a double


% --- Executes during object creation, after setting all properties.
function editBM3NoReps_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editBM3NoReps (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end


% --- Executes on button press in checkboxSFS.
function checkboxSFS_Callback(hObject, eventdata, handles)
% hObject    handle to checkboxSFS (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of checkboxSFS



function editSFSMaxVars_Callback(hObject, eventdata, handles)
% hObject    handle to editSFSMaxVars (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editSFSMaxVars as text
%        str2double(get(hObject,'String')) returns contents of editSFSMaxVars as a double


% --- Executes during object creation, after setting all properties.
function editSFSMaxVars_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editSFSMaxVars (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editSFSk_Callback(hObject, eventdata, handles)
% hObject    handle to editSFSk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editSFSk as text
%        str2double(get(hObject,'String')) returns contents of editSFSk as a double


% --- Executes during object creation, after setting all properties.
function editSFSk_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editSFSk (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end




% --- Executes on button press in pushbuttonLoadResult.
function pushbuttonLoadResult_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonLoadResult (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

p = inputdlg('Enter the name of a file to load', 'Load file', 1, {'[]'});
if ~isempty(p)
    filename = p{1};
    
    evalin('base', ['load ' filename ';']);
    refresh_results();
    refresh_results_selected();
end;    




% --- Executes on button press in pushbuttonSaveResult.
function pushbuttonSaveResult_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonSaveResult (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
try
    dummy = evalin('base', 'bmtool_results');
catch ME
    msgbox('No results stored!', 'Error!');
    return;
end;

p = inputdlg('Enter file name to save results into', 'Save file', 1, {'[]'});
if ~isempty(p)
    filename = p{1};
    evalin('base', ['save(''' filename ''', ''bmtool_results'');']);
    refresh_results();
    refresh_results_selected();
end;    




% --- Executes during object creation, after setting all properties.
function listboxResults_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listboxResults (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



% --- Executes on selection change in popupmenuVisualize.
function popupmenuVisualize_Callback(hObject, eventdata, handles)
% hObject    handle to popupmenuVisualize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns popupmenuVisualize contents as cell array
%        contents{get(hObject,'Value')} returns selected item from popupmenuVisualize


% --- Executes during object creation, after setting all properties.
function popupmenuVisualize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to popupmenuVisualize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: popupmenu controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end



function editCode_Callback(hObject, eventdata, handles)
% hObject    handle to editCode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editCode as text
%        str2double(get(hObject,'String')) returns contents of editCode as a double


% --- Executes during object creation, after setting all properties.
function editCode_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editCode (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
