% function histogram = build_bm3_histogram(dataset, modelset, max_vars, perc_train, no_reps)
%
%
function histogram = build_bm3_histogram(dataset, modelset, max_vars, perc_train, no_reps)


nf = length(dataset.x);
histogram = zeros(1, nf);

modelset = modelset_boot(modelset, dataset);

o = feasel_new();
o.ms = modelset;
o.max_vars = max_vars;
o.no_reps = 1;
o.validation_type = 'bootstrap';
o.perc_train = perc_train;
o.min_vars = 1;
o.flag_forward = 1;

o.ds = dataset;

for j = 1:no_reps
    o = feasel_go_stepwise(o);
    
    logg = o.logs(end);
    idxs = logg.cases(logg.idx_best).idxs;
    histogram(idxs) = histogram(idxs)+1;
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
