% function rate = est_get_rate(est, data_test)
%
% Calculates the classification rate for a classification object
function rate = est_get_rate(o_est, data_test)
if ~isempty(data_test.classes)
    rate = sum(strcmp(classes2labels(o_est.classes, o_est.class_labels), ...
                      classes2labels(data_test.classes, data_test.class_labels) ...
                     ))/size(data_test.X, 1);
else
    rate = -1;
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
