% function out = class_labels2cell(class_labels, new_hierarchy)
%
% new_hierarchy is a 1-based list. is it ok? 
function out = class_labels2cell(class_labels, new_hierarchy)

no = length(class_labels);
no_levels = 0;
for i = 1:no
    no_levels = max(no_levels, sum(class_labels{i} == '|')+1);
end;

NO_COLS_FIXED = 4;
out = cell(no, no_levels+NO_COLS_FIXED);

for i = 1:no
    out{i, 1} = i-1; % old class index
    out{i, 2} = class_labels{i};
    
    % properties to be filled out later
    out{i, 3} = ''; % name_modified
    out{i, 4} = -1; % new class index

    c = regexp(class_labels{i}, '\|', 'split');
    out(i, NO_COLS_FIXED+1:NO_COLS_FIXED+length(c)) = c;
end;

% Fills gaps with empty spaces. TODO there may be an error here with this "length(c)"
for j = NO_COLS_FIXED+1:NO_COLS_FIXED+length(c)
    len_max = 0;
    for i = 1:no
        len_max = max(len_max, length(out{i, j}));
    end;
    spaces = ones(1, len_max)*' ';
    
    for i = 1:no
        out{i, j} = [out{i, j} spaces(1:len_max-length(out{i, j}))];
    end;
end;


flag_new_hierarchy = exist('new_hierarchy', 'var') && ~isempty(new_hierarchy);
if flag_new_hierarchy
    for i = 1:no
        out{i, 3} = cell2class_label(out(i, new_hierarchy+NO_COLS_FIXED));
    end;

    % Sort in the new hierarchy order in order to count and assign new class indexes
    out = sortrows(out, 3);

    s_cmp = '';
    idx = -1;
    for i = 1:no
        if ~strcmp(s_cmp, out{i, 3})
            idx = idx+1;
            s_cmp = out{i, 3};
        end;
        out{i, 4} = idx;
    end;

    if flag_new_hierarchy
        % Puts in the original order again
        out = sortrows(out, 1);
    end;

else
    for i = 1:no
        out{i, 3} = out{i, 2};
        out{i, 4} = out{i, 1};
    end;
end;
    


% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
