% function varargout = colors3(scheme)
%
% scheme is a number but currently there is only one scheme available
%
% if no output argument is specified, throws colors into the COLORS global
function varargout = colors3(scheme)

cc = scheme1();
colors = {};
for i = 1:length(cc)
    colors{end+1} = cc(i, :);
end;

if nargout == 0
    global COLORS;
    COLORS = colors;
else
    varargout = {colors};
end;


function cc = scheme1()
cc = [27, 158, 119; 217, 95, 2; 117, 112, 179]/255;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
