% Makes default COLORS, MARKERS and MARKERSIZES global variables
%
% COLORS is a cell of either char colors such as 'r', 'g'; or RGB triples
% such as [1, 0, 0], [0, .5, .5]
%
% MARKERS is a char array
% MARKERSIZES is a vector, sizes are around 6
% The two last ones must have the same size

function colors_markers()
global COLORS MARKERS MARKERSIZES FONT FONTSIZE;
COLORS = {'r', 
          'b', 
          'g', 
          'm',
          [1, .5, 0], 
          'k',
          'y',
          [.67, 0, 0], 
          [0, 0, .67],
          'c', 
          [0, .67, 0],
          [.67, .67, 0],
          [0, .67, .67],
          [.67, 0, .67]
};

MARKERS = 'so^dvp<h>';
MARKERSIZES = 2*[3 4 3 3 3 3 3 3 3];


FONT = 'Arial';
FONTSIZE = 45; % Becomes aprox. 16.5 when a 300dpi PNG is exported and made 18cm wide in Word. 
               % PS: I think it goes well on my 1650x... monitor but a different screen size would need another FONTSIZE
               % to achieve the same effect (i.e. font size of 16.5 in Word)
               % This is good provision for potential reduction when the figure goes to the paper
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
