function s = confusion_str(cc, class_labels)

no_classes = length(class_labels);
maxlen = 0;
for i = 1:no_classes
    maxlen = max(maxlen, length(class_labels{i}));
end;
numlen = max(maxlen, 6); % guarantees a mininum 999.99 mask

% col_width = (numlen+1)*no_classes+maxlen+1; % +1 for vert spaces; +1 for '\n'
% no_rows = no_classes+1;
s = char(32)*ones(1, maxlen);
spaces = char(32)*ones(1, numlen);
for i = 1:no_classes
    s_ = [spaces class_labels{i}];
    s = [s ' ' s_(end-numlen+1:end)];
end;
s = [s char(10)];

for i = 1:no_classes
    s_ = [class_labels{i} spaces];
    s =  [s s_(1:maxlen)];
    for j = 1:no_classes
        s_ = [spaces sprintf('%6.2f', cc(i, j)*100)];
        s =  [s ' ' s_(end-numlen+1:end)];
    end;
    s = [s char(10)];
end;


% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
