function varargout = data_2classes_ttest(dswork)

pieces = data_split_classes(dswork);

if length(pieces) ~= 2
    error('Dataset has %d classes, should have 2!', length(pieces));
end;

nf = size(dswork.X, 2);

for i = 1:nf
    [h, p(i)] = ttest2(pieces(1).X(:, i), pieces(2).X(:, i), 0.05);
    
end;

if nargout == 2
    varargout = {dswork, p};
else
    varargout = {p};
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
