%
% CCA according to Hastie, The elements of Statistical Learning, 2001, Algorithm 3.2, p.68
%
% Inputs
%   no_factors: number of variables to be calculated.
function [dx, dy] = data_cca(data, P)

if ~exist('P', 'var')
    P = 0;
end;

d2 = data;

Y = classes2boolean(data.classes);

[A, B] = cca(data.X, Y, P);

dx = data_transform_linear(data, A, 'cca_x', data_normalize(data.X, 's'));
dy = data_transform_linear(data_set_X(data, data_normalize(Y, 's')), B, 'cca_y');


% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
