% function data = data_curve2peakpos(data, map)
%
% Inputs:
%   map: [wn1, wn2, flag_min; ...]
function data = data_curve2peakpos(data, map)

map_idx = map;
map_idx(:, 1:2) = v_x2ind(map(:, 1:2), data.x);

T = peak_landmarks(data.X, map_idx);

data = data_set_X(data, data.x(T));

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
