function data = data_deconv(data, h)

if length(h)/2 == floor(length(h)/2)
    error('Odd-length filter, please!');
end;

h = h/norm(h);

offset = (length(h)-1)/2;

[no, nf] = size(data.X);
X = zeros(no, nf-2*offset);

for i = 1:no
    X(i, :) = deconv(data.X(i, :), h);
end;

data.X = X;
data.x = data.x(1+offset:end-offset);

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
