function data = data_draw_3dhist(data, cc)

no_features = size(data.X, 2);
min_data = min(min(data.X));
max_data = max(max(data.X));

hist_no_divisions = 100;
hist_space = linspace(min_data, max_data, hist_no_divisions);
mm = zeros(hist_no_divisions, no_features);
for i = 1:no_features
    mm(:, i) = hist(data.X(:, i), hist_space);
end;

% Scaling between 0 and 1
mm = mm/max(max(mm))*100;


% mm = [zeros(1, no_features); mm; zeros(1, no_features)];
% mm = [zeros(size(mm, 1), 1) mm zeros(size(mm, 1), 1)];


if ~exist('cc', 'var')
    cc = mm;
end;


[xx, yy] = meshgrid(data.x, hist_space);

if length(cc) == 1
    cc = ones(size(xx, 1), size(xx, 2))*cc;
end;


surf(xx, yy, mm, cc);
format_wn(data);
set(gca, 'YLim', [min_data, max_data]);
zlabel('%');
title('Surface of histograms');
shading('interp');
format_frank();

data.hist_space = hist_space;
data.mm = mm;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
