% function data = data_draw_covariance(data, which = 'c', y_ref = mean(data.X, 1))
%
% which: 'c': covariance; 'w': within-class covariacne matrix; 'b': between-class covariance matrix
function data = data_draw_covariance(data, which, y_ref)
% Plots covariance matrices

if ~exist('which', 'var')
    which = 'c';
end;

if ~exist('y_ref', 'var')
  y_ref = mean(data.X, 1);
end;

no = size(data.X, 1);
if which == 'c'
    C = data.X'*data.X/no;
else
    [SB, SW] = calculate_scatters(data, 0, 0);
    
    if which == 'w'
        C = SW;
    else
        C = SB;
    end;
    C = C/no;
end;

draw_covariance(C, data.x, y_ref);
    

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
