% function data = data_draw_hist(data, index)
function data = data_draw_hist(data, index, hist_space, color)

hist_curve = hist(data.X(:, index), hist_space);
hist_curve = hist_curve/sum(hist_curve)*100;
bar(hist_space, hist_curve, color);
title(sprintf('%4.0f cm^-^1', data.x(index)));
set(gca, 'YLim', [0, 100]);
ylabel('%');
format_frank(gcf);

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
