% function data_draw_pca_pareto(dataset_name, no_pcs)
function data_draw_pca_pareto(data, no_pcs)

data = data_eliminate_var_0(data, 1e-10);

var_total = sum(var(data.X));


data_pca = data_transform_pca(data, no_pcs, 1);

vars = var(data_pca.X)/var_total*100;
figure;
plot(1:no_pcs, integrate(vars), 'k', 'LineWidth', 2);
hold on;
bar(1:no_pcs, vars);
set(gca, 'XLim', [0, no_pcs+1]);
set(gca, 'XTick', 1:no_pcs);
title('PCA pareto chart');
xlabel('PC');
ylabel('% variance explained');
format_frank();
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
