% varargout = data_eliminate_outliers_by_density(data)
%
% Interactive function: calculates data densities; plots a figure; then
% asks user for cut point
%
% Takes a while, go make some tea
function varargout = data_eliminate_outliers_by_density(data)

if 1
    [data, densities, indexes_original] = data_sort_distance(data, 'density', 200);
    save('densities.mat', 'densities', 'indexes_original');
else
    load densities.mat;
    data = data_map_rows(data, indexes_original);
end;


figure;
plot(densities);
xlabel('Spectrum index');
ylabel('Data density');
format_frank(gcf, 1.5);


while 1
    cut_point = input('Enter cut point (inclusive): ');
    
    figure; 
    subplot(1, 2, 1); 
    plot(data.x, data.X(1:cut_point, :)');
    format_wn();
    subplot(1, 2, 2);
    plot(data.x, data.X(cut_point+1:end, :)');
    format_wn();
    
    
    flag = input('Are you sure (0/1)? ');
    if flag
        break;
    end;
end;

indexes_in = cut_point+1:size(data.X, 1);

data = data_map_rows(data, indexes_in);
indexes_original = indexes_original(indexes_in);

% Gotta put spectra in a fair order again
[data, idxs] = data_sort_by_colony(data);
indexes_original = indexes_original(idxs);

if nargout == 1
    varargout = {data};
else
    varargout = {data, indexes_original};
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
