% varargout = data_eliminate_outliers_by_distance(data, diff_order, threshold)
%
% Sorts spectra according to distance from the mean spectra
function varargout = data_eliminate_outliers_by_distance2(data, no_stds)


diff_order = 2;


[data, dists, indexes_original] = data_sort_distance(data);

ddists = diff(dists, diff_order);
ddistsstd = (ddists-mean(ddists))/std(ddists);

fprintf('Max deviation: %g stds\n', max(abs(ddistsstd)));

if 1
    figure;
    plot(ddistsstd);
end;


v = 1:length(ddists);
idxs_above = v(ddistsstd >= no_stds);

if ~isempty(idxs_above)
    idx_last = idxs_above(1)+diff_order-1;
    indexes_in = 1:idx_last;
    fprintf('Info: outliers removed: %d.\n', size(data.X, 1)-length(indexes_in));

else
    disp('Warning: sorry, could not find an outlier beginning, no outlier removed. plot(ddists) to have a look.');
    indexes_in = 1:size(data.X, 1);
end;

data = data_map_rows(data, indexes_in);
indexes_original = indexes_original(indexes_in);

% Gotta put spectra in a fair order again
[data, idxs] = data_sort_by_colony(data);
indexes_original = indexes_original(idxs);



if nargout == 1
    varargout = {data};
else
    varargout = {data, indexes_original};
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
