% varargout = data_eliminate_outliers_by_distance3(data, no_stds)
%
% Mahalanobis distance
function varargout = data_eliminate_outliers_by_distance3(data, no_stds)

diff_order = 0;
no_obs = size(data.X, 1);

[data, dists, indexes_original] = data_sort_distance(data, 1);
% fprintf('Max Mahalanobis distance: %g\n', max(abs(dists)));

dists = diff(dists, diff_order);


if 1
    figure;
    plot(dists);
end;


v = 1:length(dists);
idxs_above = v(dists >= no_stds);

if ~isempty(idxs_above)
    idx_last = idxs_above(1)+diff_order-1;
    indexes_in = 1:idx_last;
else
    indexes_in = 1:no_obs;
end;
no_removed = no_obs-length(indexes_in);
fprintf('Info: outliers removed: %d.\n', no_removed);

data = data_map_rows(data, indexes_in);
indexes_original = indexes_original(indexes_in);

% Gotta put spectra in a fair order again
[data, idxs] = data_sort_by_colony(data);
indexes_original = indexes_original(idxs);



if nargout == 1
    varargout = {data};
else
    varargout = {data, indexes_original};
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
