% varargout = data_eliminate_outliers_by_distance3(data, no_stds)
%
% Mahalanobis distance
function varargout = data_eliminate_outliers_by_distance4(data)

no_obs = size(data.X, 1);

[data, dists, indexes_original] = data_sort_distance(data, 1);
% fprintf('Max Mahalanobis distance: %g\n', max(abs(dists)));


% prepares x axis for sampling 'dists'
dists1 = diff(dists');
qq = round(quantile_landmarks(integrate(dists1), 100));
if qq(1) ~= 1
    qq = [1 qq];
end;
if qq(end) ~= no_obs
    qq = [qq no_obs];
end;

sp = spaps(qq, dists(qq), 1); %, w, 3);

dism = fnval(sp, 1:no_obs);



%%




idx_cut = 0;


if 1
%     dism2m = dism2-mean(dism2);
    if 1
        diff_order = 1;

        dismf = diff(dism, diff_order);
        if 1
            figure;
            plot(dismf);
        end;
        
        idx = find(dismf > .02); % gap of more than 1 standard deviation
        if ~isempty(idx)
            idx_cut = idx(end);
        end;          
    else
        diff_order = 2;
        dism2 = diff(dism, diff_order);
        
        dism2(dism2 < 0) = 0; % to prevent from picking negative peaks

        if 1
            figure;
            plot(dism2);
        end;

        pp = find_peaks(dism2);
        ppval = dism2(pp);
        mean_ppval = mean(ppval);
        idxs = find(ppval > 5*mean_ppval);

        if ~isempty(idxs)
            idx_cut = pp(idxs(end));
        end;
    end;
else
    diff_order = 2;

    dism2 = diff(dism, diff_order);

    if 1
        figure;
        plot(dism2);
    end;
    
    no_avg = 10;
    gap_thresh = 10;
    max_gap = -Inf;
    for i = round(length(dism2)*.9):length(dism2)
        gap = dism2(i)-mean(dism2((i-no_avg):(i-1)));
        if gap > max_gap
            max_gap = gap;
            fprintf('max_gap = %g @ %d\n', max_gap, i);
        end;

        if gap >= gap_thresh
            idx_cut = i;
            break;
        end;
    end;

    fprintf('Info: maximum gap in 2nd derivative: %g.\n', max_gap);
end;

if idx_cut > 0
    idx_last = idx_cut+diff_order-1;
    indexes_in = 1:idx_last;
else
    indexes_in = 1:no_obs;
end;
no_removed = no_obs-length(indexes_in);
fprintf('Info: outliers removed: %d.\n', no_removed);

data = data_map_rows(data, indexes_in);
indexes_original = indexes_original(indexes_in);

% Gotta put spectra in a fair order again
[data, idxs] = data_sort_by_colony(data);
indexes_original = indexes_original(idxs);



if nargout == 1
    varargout = {data};
else
    varargout = {data, indexes_original};
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
