% Calculated the 'cluster vectors'
function cv = data_get_cv(data, class_origin)

if ~exist('class_origin', 'var')
    class_origin = -1;
end;

if class_origin > -1
    pieces = data_split_classes(data);
    v_shift = -mean(pieces(class_origin+1).X, 1)';
else
    v_shift = 0;
end;

% v_shift = 0;
[no_fea1, no_fea2] = size(data.L);
% % % forget about this lambdas = ones(no_fea2, 1); % Just in case we ever to ponderate the loadings

% Calculates CL 'class loadings'
pieces = data_split_classes(data);
no_classes = length(pieces);

cv = zeros(no_fea1, no_classes);

for k = 1:no_classes
    m = mean(pieces(k).X, 1)'; % mean vector: averages each column of dataset for class k (the transpose makes it a column vector)
    cv(:, k) = data.L*(m+v_shift);
end;



% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
