% names = data_get_feature_names(data, idx_fea)
function names = data_get_feature_names(data, idx_fea)

names = {};
for i = 1:length(idx_fea)
    if strcmp(data.domain, 'original')
        s = sprintf('Feature %g', data.x(idx_fea(i)));
    elseif strcmp(data.domain, 'pca')
        s = sprintf('PC%d', idx_fea(i));
    elseif strcmp(data.domain, 'lda') || strcmp(data.domain, 'pcalda')
        s = sprintf('LD%d', idx_fea(i));
    else
        s = sprintf('Fea %d', idx_fea(i));
    end;
    
    names{i} = s;
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
