% Isolates a particular class, so it will be class 0 and all the other will
% be class 1
function data = data_isolate_class(data, class)

score_code = data.class_labels{class+1};
no_obs = size(data.X, 1);

for i = 1:no_obs
    if data.classes(i) == class
        data.classes(i) = 0;
    else
        data.classes(i) = 1;
    end;
end;
data.class_labels = {score_code, 'All other classes'};
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
