% Isolates a particular class, so it will be class 0 and all the other will
% be class 1
function data2 = data_isolate_classes(data, class1, class2)

data2 = data;
data2.class_labels = {data.class_labels{class1+1}, data.class_labels{class2+1}};

no_obs = size(data.X, 1);

ptr_x = 0;
for i = 1:no_obs
    class = data.classes(i);
    if class == class1 || class == class2
        ptr_x = ptr_x+1;
        data2.X(ptr_x, :) = data.X(i, :);
        if class == class1
            data2.classes(ptr_x, :) = 0;
        else
            data2.classes(ptr_x, :) = 1;
        end;
    end;
end;
data2.X = data2.X(1:ptr_x, :);
data2.classes = data2.classes(1:ptr_x, :);
keyboard;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
