% function data = data_line_correct(data, wns, no_convolutions)
%
% no_convolutions: number of convolutions from [1, 1, 1] in the average filter
%
% wns:
% IINITIAL = 1; IFINAL = 2; IFLAG0 = 3; IFLAGMIN = 4; INOCONV = 5
%
% IFLAG0 has prioriry over IFLAGMIN: if the former is 0, the latter is treated as 1
% if number of convolutions is 0, the average coefficients vector will be [1]

function data = data_line_correct2(data)

NOCONV_DEFAULT = 4;

% Constants to access columns of 'wns'
IINITIAL = 1;
IFINAL = 2;
IFLAG0 = 3;
IFLAGMIN = 4;
INOCONV = 5;



[no_obs, no_fea] = size(data.X);


for i = 1:no_obs
    flag_loose = 1;
    
    spectrum = data.X(i, :);
    idxs = [];
    while 1
        cnt = 0;
        if flag_loose
            [val, idx_cut] = min(spectrum);
            idxs(end+1) = idx_cut;
            idx_left = idx_cut-1;
            idx_right = idx_cut+1;
            flag_loose = 0;
        else
            if idx_left > 1
                [val, idx] = min(spectrum(1:idx_left));
                idxs(end+1) = idx;
                idx_left = idx-1;
            else
                cnt = cnt+1;
            end;
        
            if idx_right < no_fea
                [val, idx] = min(spectrum(idx_right:end));
                idxs(end+1) = idx+idx_right-1;
                idx_right = idx+idx_right-1+1;
            else
                cnt = cnt+1;
            end;
        end;
        
%        x = input(sprintf('olha aih: %d, %d: ', idx_left, idx_right));
%        if x == 1
%          return;
%          end;
        
        if cnt == 2
            break;
        end;
    end;
    
    idxs = sort(idxs);
    line = zeros(1, no_fea);
    line(1:idxs(1)) = spectrum(idxs(1));
    line(idxs(end)+1:no_fea) = spectrum(idxs(end));
    for j = 1:length(idxs)-1
        lennow = idxs(j+1)-idxs(j);
        line(idxs(j)+1:idxs(j+1)) = linspace(spectrum(idxs(j)+1), spectrum(idxs(j+1)), lennow);
    end;
    
    keyboard;
    
    data.X(i, :) = data.X(i, :)-line;    
end;
        
        
        
        


% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
