% function data = data_line_correct_authentic(data, wnrange1, wnrange2)
function data = data_line_correct_authentic(data, wnrange1, wnrange2)

% % % NOCONV_DEFAULT = 4;
% % % 
% % % % Constants to access columns of 'wns'
% % % IINITIAL = 1;
% % % IFINAL = 2;
% % % IFLAG0 = 3;
% % % IFLAGMIN = 4;
% % % INOCONV = 5;
% % % 


[no_obs, no_fea] = size(data.X);


% % % % % % % converts wns to struct if needed
% % % % % % [nq, nw] = size(wns);
% % % % % % flag_wnisstruct = (nw == IFLAGMIN || nw == INOCONV) && sum(wns(1, IFLAG0) == [0 1]) > 0 && sum(wns(1, IFLAGMIN) == [0 1]) > 0;
% % % % % % if ~flag_wnisstruct
% % % % % %     % If single wavenumbers, not ranges, are in wns, defaults to wns to [wn, wn, flag_zero = 1, flag_min = 1; ...]
% % % % % %     if size(wns, 1) == 1; wns = wns'; end;
% % % % % %     no = length(wns);
% % % % % %     wns = [wns wns ones(no, 1) ones(no, 1)];     
% % % % % % end;
% % % % % % 
% % % % % % if ~exist('no_convolutions', 'var') && size(wns, 2) == 4
% % % % % %     % there is no convolution information
% % % % % %     no_convolutions = NOCONV_DEFAULT;
% % % % % % end;
% % % % % %     
% % % % % % if exist('no_convolutions', 'var')
% % % % % %     if length(no_convolutions) == 1
% % % % % %         no_convolutions = ones(size(wns, 1), 1)*no_convolutions;
% % % % % %     end;
% % % % % %     if size(no_convolutions, 2) > 1
% % % % % %         no_convolutions = no_convolutions';
% % % % % %     end;
% % % % % %     if size(wns, 2) == 4
% % % % % %         wns(1, 5) = 0; % Expands wns to 5th column
% % % % % %     end;
% % % % % %     wns(:, 5) = no_convolutions;
% % % % % % end;
% % % % % %         
    

% transforms wns in indexes. knots is parallel to first 2 columns of wns
knots = v_x2ind([wnrange1(1), wnrange1(2); wnrange2(1), wnrange2(2)], data.x);
no_knots = size(knots, 1);




% baseline correction

% means = mean(data.X, 1); % row vector containing column means
for iobs = 1:no_obs
%     if flag_record
%         baseline = zeros(1, no_fea);
%     end;
    
    for iknot = 1:no_knots
        idxshoriz = knots(iknot, 1):knots(iknot, 2);
        [val, idxindeed] = min(data.X(iobs, idxshoriz));
        idxindeed = idxindeed+idxshoriz(1)-1;
        
        % applies average filter to region centered in a minimum/maximum
%         av = filters{iknot}*data.X(iobs, idxindeed-filter_shifts(iknot):idxindeed+filter_shifts(iknot))';

%         if ~wns(iknot, IFLAG0) % ~IFLAG0 is average
%             shifty = means(idxindeed);
%         else
%             shifty = 0;
%         end;
%         
        if iknot > 1

    
            p = polyfit([idxindeed_, idxindeed], [val_, val], 1);
            
            idx1 = idxindeed_+1;
            idx2 = idxindeed;          
          
            idxs = idx1:idx2;
            v = polyval(p, idxs);
            data.X(iobs, idxs) = data.X(iobs, idxs)-v;
            data.X(iobs, 1:idx1-1) = 0;
            data.X(iobs, idx2+1:end) = 0;
            
        end;
        
        val_ = val;
        idxindeed_ = idxindeed;
        
    end;
%     if flag_record
%         baselines(iobs, :) = baseline;
% %         figure; plot([means; data.X(iobs, :); baseline]'); legend({'means', 'X', 'baseline'});
% %         input('vai nego');
% %         disp('vai nego');
%     end;
end;

% if flag_record
%     disp('hi, see the baselines');
% end;
    
data = data_update_background(data);

if no_knots > 1
    fprintf('INFO: data has been authentically line-corrected.\n');
end;


% 
% minimax = minima;
% for i = 1:no_obs
%     minimax(i, :) = data.x(minima(i, :));
% end;
% 
% global dswheremin;
% dswheremin = data_set_X(data, minimax);
% 

% 
% 
% figure; 
% subplot(2, 1, 1);
% [N, X] = hist(minima(:, 1), length(knots(1, 1):knots(1, 2)));
% % bar(data.x(round(X)), N);
% bar(N);
% set(gca, 'Xdir', 'reverse');
% subplot(2, 1, 2);
% [N, X] = hist(minima(:, 2), length(knots(2, 1):knots(2, 2)));
% % bar(data.x(round(X)), N);
% bar(N);
% set(gca, 'Xdir', 'reverse');
% 
% keyboard;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
