% function data = data_map_rows(data, idxnew)
%
% reorganizes vectors in data according to idxnew
function data = data_map_rows(data, idxnew)


data.X = data.X(idxnew, :);
data.classes = data.classes(idxnew, :);

if ~isempty(data.idspectrum_s)
    data.idspectrum_s = data.idspectrum_s(idxnew, :);
end;
if ~isempty(data.idcolony_s)
    data.idcolony_s = data.idcolony_s(idxnew, :);
end;
if ~isempty(data.colony_codes)
    data.colony_codes = data.colony_codes(idxnew);
end;
if ~isempty(data.file_names)
    data.file_names = data.file_names(idxnew);
end;



% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
