% data_merged = data_merge(dataa)
%
% dataa must be a cell array with elements as structures
%
% Most output fields like .L, .previous_domain etc will be taken from the
% first element in dataa
function out = data_merge(dataa)

no = size(dataa, 2);

out = dataa(1);


out.classes = [];
out.class_labels = {};
out.X = [];
out.idspectrum_s = [];
out.idcolony_s = [];
out.file_names = {};
out.colony_codes = {};

% class_offset = 0;


for idata = 1:no
    data = dataa(idata);

    no_obs = length(data.classes);
    classesnew = -1*ones(no_obs, 1);
    for iobs = 1:no_obs
        label = data.class_labels{data.classes(iobs)+1};
        idxnew = find(strcmp(label, out.class_labels));
        if isempty(idxnew)
            len = length(out.class_labels);
            out.class_labels{len+1} = label;
            idxnew = len+1;
        else
            idxnew = idxnew(1);
        end;
        classesnew(iobs) = idxnew-1;
    end;
% % % % % % % % % % 
% % % % % % % % % %     if idata > 1
% % % % % % % % % %         no_classes1 = length(out.class_labels);
% % % % % % % % % %         no_classes2 = length(data.class_labels);
% % % % % % % % % %         
% % % % % % % % % %         no_added = 0;
% % % % % % % % % %         added_class_labels = {};
% % % % % % % % % %         indexes2 = zeros(1, no_classes2);
% % % % % % % % % %         for i_test = 1:no_classes2
% % % % % % % % % %             flag_found = 0;
% % % % % % % % % %             for i = 1:no_classes1
% % % % % % % % % %                 if strcmp(out.class_labels{i}, data.class_labels{i_test})
% % % % % % % % % %                     indexes2(i_test) = i;
% % % % % % % % % %                     flag_found = 1;
% % % % % % % % % %                     break;
% % % % % % % % % %                 end;
% % % % % % % % % %             end;
% % % % % % % % % %             
% % % % % % % % % %             if ~flag_found
% % % % % % % % % %                 no_added = no_added+1;
% % % % % % % % % %                 added_class_labels{no_added} = data.class_labels{i_test};
% % % % % % % % % %                 indexes2(i_test) = no_classes1+no_added;
% % % % % % % % % %             end;
% % % % % % % % % %         end;
% % % % % % % % % %         
% % % % % % % % % %         for i = 1:size(data.X, 1)
% % % % % % % % % %             data.classes(i) = indexes2(data.classes(i)+1)-1;
% % % % % % % % % %         end;
% % % % % % % % % %     
% % % % % % % % % %         out.class_labels = cat(2, out.class_labels, added_class_labels);
% % % % % % % % % %     else
% % % % % % % % % %         out.class_labels = data.class_labels;
% % % % % % % % % %     end;
        
    
    out.classes = [out.classes; classesnew];
    out.X = [out.X; data.X];
    out.idspectrum_s = [out.idspectrum_s; data.idspectrum_s];
    out.idcolony_s = [out.idcolony_s; data.idcolony_s];
    out.file_names = cat(1, out.file_names, data.file_names);
    out.colony_codes = cat(1, out.colony_codes, data.colony_codes);
end;


out.x = dataa(1).x;
% no need out = data_update_background(out);

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
