% function out = data_new()
% 
% Returns a empty dataset structure. Principal fields are: X, x, classes,
% class_labels.
function out = data_new()
out.X = [];
out.x = [];
out.idspectrum_s = [];
out.idcolony_s = [];
out.colony_codes = {};
out.file_names = {};
out.classes = [];
out.class_labels = {};

out.file_name = '';
out.file_type = ''; % mat or txt

out.type_norm = ''; % type of normalization that has been applied

% out.V_star = [];
% out.W_star = [];
out.L = []; % loadings of last linear transformation

out.domain = 'original'; % 'original', 'pca', 'lda', 'pcalda'

out.idx_fea = [];
out.pca_idx_fea = [];
out.lda_idx_fea = [];


out.comments = {};

out.pca_flag_rotated = 0;
out.pca_vars = [];

% These variables record the vectors necessary to plot a typical spectrum
out.background_x = [];
out.background_y = [];

out.previous_domain = '';
out.previous_x = [];

out.flag_wn = 1; % Usually a dataset has a reverse x axis
out.previous_flag_wn = 1; 
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
