% function o = data_plot_indicator_spectrum(data, maxy, color)
function o = data_plot_indicator_spectrum(data, maxy, color)


if ~isempty(data.background_x) && ~isempty(data.background_y)

    if ~exist('scale', 'var')
        scale = 1;
    end;

    if ~exist('color', 'var')
        color = 'k:';
    end;


    x = data.background_x;
    y = data.background_y/max(data.background_y(:))*maxy;

    o = plot(x, y, color);
else
    disp('Warning: data_plot_indicator_spectrum() found nothing to plot.');
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
