% function out = data_scramble(data)
%
% Applies a random permutation to data.X, .classes, .idspectrum_s and
% .idcolony_s (the same permutation for all).
%
function out = data_scramble(data)

flag_sp = isfield(data, 'idspectrum_s') && length(data.idspectrum_s) > 0;

no_obs = size(data.X, 1);
p = randperm(no_obs);

out = data_map_rows(data, p);
% 
% out = data;
% 
% for i = 1:no_obs
%     out.X(i, :) = data.X(p(i), :);
%     out.classes(i, :) = data.classes(p(i), :);
%     if flag_sp
%         out.idspectrum_s(i, :) = data.idspectrum_s(p(i), :);
%         out.idcolony_s(i, :) = data.idcolony_s(p(i), :);
%     end;
% end;

disp('INFO (data_scramble()): Data was scrambled');
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
