% function out = data_select_colonies(data, idxs_codes)
%
% See also: data_new
function out = data_select_colonies(data, idxs_codes)

no_obs = size(data.X, 1);
code_old = '';
ptr_code = 0;
ptr_obs = 0;
flag_goes = 0;
idxs_obs = zeros(1, no_obs);
str_codes = '';
for i = 1:no_obs
    code = data.colony_codes{i};

    if ~strcmp(code, code_old)
        ptr_code = ptr_code+1;
        flag_goes = sum(idxs_codes == ptr_code) > 0;
        code_old = code;
        
        if flag_goes
            if ptr_obs > 1
                str_codes = [str_codes ', '];
            end;
            str_codes = [str_codes code];
        end;
    end;
    
    if flag_goes
        ptr_obs = ptr_obs+1;
        idxs_obs(ptr_obs) = i;
    end;
end;

idxs_obs = idxs_obs(1:ptr_obs);
piece = data_split_map(data, {idxs_obs});
out = piece(1);

fprintf('INFO (data_select_colonies()): codes selected: %s.\n', str_codes);
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
