% function out = data_select_hierarchy(data, hierarchy)
function data = data_select_hierarchy(data, hierarchy)

if ~exist('hierarchy', 'var')
    hierarchy = [];
end;

no_obs = size(data.X, 1);
comoassim = class_labels2cell(data.class_labels, hierarchy);

no_classes = length(data.class_labels);
no_h = length(hierarchy);
newcl = cell(1, no_classes);
for i = 1:no_classes
    s = '';
    for j = 1:no_h
        if j > 1
            s = [s '|'];
        end;
        s = [s comoassim{i, hierarchy(j)+4}];
    end;
    newcl{i} = s;
end;

data.class_labels = newcl;

data = data_merge(data);  % data_merge() makes the favour of eliminating repeating class labels (and renumbering the classes accordingly, of course)
% data = data_sort_class_labels(data);
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
