% data = data_set_X(data, X)
function data = data_set_X(data, X)

data.X = X;

[no_obs, no_fea] = size(X);

% Checks stuff regarding columns
if length(data.x) ~= no_fea
    data.x = 1:no_fea;
end;

if length(data.idspectrum_s) ~= no_obs
    data.idspectrum_s = -(1:no_obs)';
end;
if length(data.idcolony_s) ~= no_obs
    data.idcolony_s = -1*ones(1, no_obs)';
end;
if length(data.file_names) ~= no_obs
    data.file_names = cell(no_obs, 1);
    for i = 1:no_obs
        data.file_names{i} = '';
    end;
end;
if length(data.colony_codes) ~= no_obs
    data.colony_codes = cell(no_obs, 1);
    for i = 1:no_obs
        data.colony_codes{i} = sprintf(['%0' int2str(floor(log10(no_obs))+1) 'd'], i);
    end;
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
