% function varargout = data_sort_by_colony(data)
%
% Returns:
%
%     data
%
%   or
%
%     {data, idxs}
function varargout = data_sort_by_colony(data)


[vals, idxs] = sortrows(data.colony_codes);

data = data_map_rows(data, idxs);

if nargout == 2
    varargout = {data, idxs};
else
    varargout = {data};
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
