% function data = data_sort_class_labels(data)
%
% Sorts data.class_labels and renumbers data.classes accordingly
function data = data_sort_class_labels(data)


no_classes = length(data.class_labels);
[data.class_labels, indexes0] = sort(data.class_labels);

indexes_new = zeros(1, no_classes);
for i = 1:no_classes
    indexes_new(i) = find(indexes0 == i);
end;


for i = 1:size(data.X, 1)
    data.classes(i) = indexes_new(data.classes(i)+1)-1;
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
