% [data1, data2] = data_split_proportion(proportion, data)
%
% Splits data into data1 and data2 according do proportion
function [data1, data2] = data_split_proportion(data, proportion)

no_obs = size(data.X, 1);
no1 = floor(no_obs*proportion);
pieces = data_split_map(data, {1:no1, no1+1:no_obs});
data1 = pieces(1);
data2 = pieces(2);

data1.comments{end+1} = sprintf('%g of original sample size', proportion);
data2.comments{end+1} = sprintf('%g of original sample size', 1-proportion);
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
