% function d2 = data_transform_lda2(data, flag_sphere=1, flag_modified_s_b=0, min_lds=1)
%
% Inputs:
%   data: structure
%   flag_sphere: see fisher_ld()
%   flag_modified_s_b: see calculate_scatters()
function data = data_transform_lda2(data, flag_sphere, flag_modified_s_b, min_lds)

if ~exist('flag_modified_s_b', 'var')
    flag_modified_s_b = 0;
end;

if ~exist('flag_sphere', 'var')
    flag_sphere = 1;
end;

if ~exist('min_lds', 'var')
    min_lds = 1;
end;


i = 0;
cnt_ld = 0;
Lnow = [];
while 1
    if cnt_ld >= min_lds
        break;
    end;
    
    if i == 0
        dnow = data;
    else
        % The aim is to reconstruct X and make a new dataset ortogonal to the reconstruction
        %
        % This formulation projects X onto the columnspace of the loadings and then subtracts the projection from the
        % original
        X1 = data.X*Lnow*inv(Lnow'*Lnow)'*Lnow';
        X2 = dnow.X-X1;
        dnow = data;
        data_set_X(dnow, X2);


        
%         % This formulation projects the original dataset onto the nullspace of the loadings^T. Gives the same
%         % new X (with numerical differences in the order or 1e-15)
        
%         % This alternative formulation works but I will stick to the above one because it is
%         L2 = null(Lnow');
%         L3 = L2*inv(L2'*L2)'*L2';
%         dnow = data_transform_linear(dnow, L3);
        
        
    end;
    
    dtemp = data_transform_lda(dnow, flag_sphere, flag_modified_s_b);
    Lnow = [Lnow dtemp.L];
    
    cnt_ld = size(Lnow, 2);
    i = i+1;
end;


% A, pronto
data = data_transform_linear(data, Lnow);


% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
