% function data = data_transform_linear(data, L, new_domain_name='lt', X = data.X)
%
% Transforms data using matrix L:
%   data.X = data.X*L;
%
% L[no_features][any]
function data = data_transform_linear(data, L, new_domain_name, X)

if ~exist('new_domain_name', 'var')
    new_domain_name = 'lt';
end;
if ~exist('X', 'var')
    X = data.X;
end;


data.previous_domain = data.domain;
data.previous_x = data.x;
data.previous_flag_wn = data.flag_wn;

% Stores means for plotting loadings
% TODO this is not well resolved. I want mean_y to prevail even after e.g.
% normalization
% data.background_y = mean(data.X, 1);
% data.background_x = data.x;


data.domain = new_domain_name;
data.x = 1:size(L, 2);
data.idx_fea = data.x;
data.flag_wn = 0;  % This may not be the case but I don't know any counterexample so far

data.L = L;
data.X = X*L;


% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
