% function out = data_transform_linear_crossval(data, fcn, k)
function varargout = data_transform_linear_crossval(data, fcn, k)

no = size(data.X, 1);

idxs = crossvalind('Kfold', no, k);
idxsall = 1:no;


for i = 1:k
    idxstrain = idxsall(idxs ~= i);
    idxstest = idxsall(idxs == i);
    
    dataL = fcn(data_map_rows(data, idxstrain));
    
    if i == 1
        Lref = dataL.L;
    else
        % Inverts the vector if the angle with the reference vector is greater than 90 degrees
        for j = 1:size(Lref, 2)
            if Lref(:, j)'*dataL.L(:, j) < 0
                dataL.L(:, j) = -dataL.L(:, j);
            end;
        end;
    end;
    
    
    pieces(i) = data_transform_linear(data_map_rows(data, idxstest), dataL.L);

%     figure; 
%     data_plot_scatter_2d(pieces(i), [1 2], []);


    LL(:, :, i) = dataL.L;
end;


out = data_merge(pieces);

if nargout == 1
    varargout = {out};
else
    varargout = {out, LL};
end;


% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
