% function d2 = data_transform_pls(data, no_factors)
%
% PLS according to Hastie, The elements of Statistical Learning, 2001, Algorithm 3.2, p.68
%
% Inputs
%   no_factors: number of variables to be calculated.
function d2 = data_transform_pls(data, no_factors)

if ~exist('no_factors', 'var')
    no_factors = 1;
end;


% % % % % % % % % % % % % % % % % % % % % % % % % % [no, nf] = size(data.X);
% % % % % % % % % % % % % % % % % % % % % % % % % % p = min(no_factors, nf);
% % % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % % % Y = data.classes;
% % % % % % % % % % % % % % % % % % % % % % % % % % Y = data_normalize(Y, 's');
% % % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % % % L = zeros(nf, p);
% % % % % % % % % % % % % % % % % % % % % % % % % % X = data_normalize(data.X, 's'); % We need this otherwise the correlation X'*Y needs normalization
% % % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % % % % penalty
% % % % % % % % % % % % % % % % % % % % % % % % % % if 1
% % % % % % % % % % % % % % % % % % % % % % % % % %     M = eye(nf, nf);
% % % % % % % % % % % % % % % % % % % % % % % % % % else
% % % % % % % % % % % % % % % % % % % % % % % % % %     % Kr�mer, Boulesteix, Tutz: Penalized Partial Least Squares Based on B-Splines Transformations
% % % % % % % % % % % % % % % % % % % % % % % % % %     % http://epub.ub.uni-muenchen.de/1853/1/paper_485.pdf
% % % % % % % % % % % % % % % % % % % % % % % % % %     % a nice and clear paper
% % % % % % % % % % % % % % % % % % % % % % % % % %     dcoeff = [1, 10, 10]*no;
% % % % % % % % % % % % % % % % % % % % % % % % % %     P = zeros(nf, nf);
% % % % % % % % % % % % % % % % % % % % % % % % % %     for i = 1:length(dcoeff)
% % % % % % % % % % % % % % % % % % % % % % % % % %         D = diff_operator(nf, i-1);
% % % % % % % % % % % % % % % % % % % % % % % % % %         P = P+dcoeff(i)*(D'*D);
% % % % % % % % % % % % % % % % % % % % % % % % % %     end;
% % % % % % % % % % % % % % % % % % % % % % % % % %     
% % % % % % % % % % % % % % % % % % % % % % % % % %     M = inv(P);
% % % % % % % % % % % % % % % % % % % % % % % % % % end;
% % % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % % % for m = 1:p
% % % % % % % % % % % % % % % % % % % % % % % % % %     % Coefficients are correlations between X and Y
% % % % % % % % % % % % % % % % % % % % % % % % % %     L(:, m) = M*X'*Y;
% % % % % % % % % % % % % % % % % % % % % % % % % %     
% % % % % % % % % % % % % % % % % % % % % % % % % %     z = X*L(:, m);
% % % % % % % % % % % % % % % % % % % % % % % % % %     
% % % % % % % % % % % % % % % % % % % % % % % % % %     % Makes columns in X orthogonal to the newfound z.
% % % % % % % % % % % % % % % % % % % % % % % % % %     normz2 = z'*z;
% % % % % % % % % % % % % % % % % % % % % % % % % % %     Z = repmat
% % % % % % % % % % % % % % % % % % % % % % % % % %     for j = 1:nf
% % % % % % % % % % % % % % % % % % % % % % % % % %         X(:, j) = X(:, j)-z*(z'*X(:, j)/(z'*z));
% % % % % % % % % % % % % % % % % % % % % % % % % %     end;
% % % % % % % % % % % % % % % % % % % % % % % % % % end;


d2 = data;

[Z, L] = pls(data.X, data.classes, no_factors);

d2 = data_transform_linear(d2, L, 'pls', data_normalize(data.X, 'c'));

% % % % d2.previous_domain = data.domain;
% % % % d2.previous_x = data.x;
% % % % 
% % % % d2.set_X(data_normalize(data.X, 'c')*L);
% % % % d2.L = L;
% % % % d2.domain = 'pls';
% % % % 
% % % % v = 1:p;
% % % % d2.x = v;
% % % % d2.idx_fea = v;
% % % % 

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
