% function dscoef       = data_transform_splinebasis(data, no_basis)
% function [dscoef, fd] = data_transform_splinebasis(data, no_basis)
function varargout = data_transform_splinebasis(data, no_basis, breaks, order)

[no, nf] = size(data.X);

tt = 1:nf;

if ~exist('order', 'var')
    order = 6;
end;
if ~exist('breaks', 'var')
    breaks = linspace(1, nf, no_basis-order+2);
end;

bb = create_bspline_basis([1, nf], no_basis, order, round(breaks));


% Makes a xx vector containing the wavenumbers corresponding to each basis function by determining where each basis
% function has its peak
PREC = 1000; % This number only determines the precision and does not affect anything else.
tt2 = linspace(1, nf, PREC); 
p = polyfit(tt, data.x, min(nf-1, 10)); % Gives a warning but who cares
x2 = polyval(p, tt2);
basismat = eval_basis(tt2, bb); % bases as columns
[vals, idxs] = max(basismat);
xx = x2(idxs);
    

% % % % % % % % % % % fd = data2fd(tt', data.X(:, :)', bb);
% % % % % % % % % % % dscoef = data;
% % % % % % % % % % % dscoef.X = getcoef(fd)';
% % % % % % % % % % % dscoef.x = xx;
% % % % % % % % % % % dscoef.domain = 'lt';
% % % % % % % % % % % dscoef.previous_flag_wn = dscoef.flag_wn;

% We gotta get the loadings matrix
tt3 = 1:nf;
B = eval_basis(tt3, bb);
% L = B;
L = B*inv(B'*B);

dscoef = data_transform_linear(data, L, 'splinecoeff');
dscoef.x = xx;
dscoef.flag_wn = data.flag_wn;

if nargout == 1
    varargout = {dscoef};
else
    varargout = {dscoef, fd};
end;
    
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
