% function diff_operator(nf, order)
%
% creates a [nf-order]x[nf] differential operator matrix D so that
% D*x = diff(x, order)
function D = diff_operator(nf, order)

if order == 0
    D = eye(nf, nf);
else
    D = diff_operator(nf-1, order-1)*diff_operator1(nf);
end;


% creates a differential operator of order 1
function D = diff_operator1(nf)
D = zeros(nf-1, nf);
for i = 1:nf-1
    D(i, i) = -1;
    D(i, i+1) = 1;
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
