%
% Outputs:
%   model: the model itself
%   est: estimation structure
function [model, est] = dist_estimate(model, data)

est = est_new_from_model_data(model, data);
tic();

Z = data.X*model.L;

no = size(data.X, 1);
nc = size(model.class_means, 2);


Y_ = zeros(no, nc);
for i = 1:nc
    X_subtract = repmat(model.class_means(:, i)', no, 1);
    X_ = Z-X_subtract;
    Y_(:, i) = sum(X_.^2, 2);
end;

Y = max(Y_(:))-Y_;

% est.Y = data_normalize(data.X, 'c')*model.coeff+repmat(model.target_means, size(data.X, 1), 1);
model.time_estimate = toc();

est = est_set_Y(est, Y);


% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
