function [xa, ya] = distribution(x, no_points, range)

if ~exist('no_points', 'var')
    no_points = 100;
end;

if ~exist('range', 'var')
    k = 0;
    extent = max(x)-min(x);
    range = [min(x)-extent*k, max(x)+extent*k];
end;


wid = std(x)/sqrt(10);  % lump width

xa = linspace(range(1), range(2), no_points);
ya = zeros(1, no_points);

for i = 1:length(x)
    ya = ya+exp(-(xa-x(i)).^2/(2*wid^2));
end;

delta_x = xa(2)-xa(1);
ya = ya/(sum(ya)*delta_x);  % sum is rough integration 
    
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
