% draw_direction(v, linescale, arrowscale)
%
% Traces a line and an arrow in direction defined by v
% v must be a COLUMN vector
% linescale = 10
% arrowscale = 3
function draw_direction(v, linescale, arrowscale)

if ~exist('linescale')
    linescale = 10;
end;
if ~exist('arrowscale')
    arrowscale = 3;
end;

x = v(1, 1);
y = v(2, 1);
plot(linescale*[-x, x], linescale*[-y, y], 'k--');
hold on;
compass(-arrowscale*x, -arrowscale*y, 'k'); % represents first eigenvector of S_W^(-1)*S_B as an arrow

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
