% draw_projections(data, v)
%
% Draws projections of each row of DATA.X onto the column vector v
% Points are colored according to DATA.classes. There must exist a global
% array called COLORS

function draw_projections(data, v)
global COLORS;

P = data.X*v*v';

for i = 1:size(data.X, 1)
    plot([data.X(i, 1), P(i, 1)], [data.X(i, 2), P(i, 2)], 'k--');
    hold on;
end;

data.X = P; % trick to save memory.
pieces = data_split_classes(data);

for i = 1:length(pieces)
    scatter(pieces(i).X(:, 1), pieces(i).X(:, 2), 30, find_color(i), 'filled');
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
