function [ mse, rmse, ndei, vaf, correl ] = errorMeasure( est, real, from, to )

error = est - real;
num = to - from + 1;
m=size(real,2);

mse = (1/num) * sum( error(from:to,:).^2 );

rmse = sqrt( (1/num) * sum( error(from:to,:).^2 ));

for i=1:m,
    ndei(i) = rmse(i)/std(real(from:to,i));
end

for i=1:m
    cor = corrcoef( est(from:to,i), real(from:to,i) );
    correl = abs(cor(1,2));
end

vaf = 100 * ( 1- ( var(error(from:to)) ./ var(real(from:to)) ) );

return;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
