% function est_calc_classes(est)
%
% Determines the classes from est.Y, which must already be set.
% Converting predictions into classification classes is a rounding problem.
function est = est_calc_classes(est)

% Determines classes
if size(est.Y, 2) > 1
    % multiple output, assumes boolean array
    [dummy, idx] = max(est.Y, [], 2);
    est.classes = idx-1;
else
    est.classes = round_random(est.Y);
    no_classes = length(est.class_labels);
    for i = 1:length(est.classes)
        if est.classes(i) < 0
            est.classes(i) = 0;
        elseif est.classes(i) > no_classes-1
            est.classes(i) = no_classes-1;
        end;
    end;
end;


% est.rate = est_get_rate(est, data_test);

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
