% function out = est_new()
%
% Creates a new estimation structure
%
% 29/09/2009: I have ambiguated this structure:
%
% 1) if .flag_per_colony == 0: .Y, .classes are regression predictions and
%      class estimation for each spectrum in the testing dataset
% 2) else: .classes will contain the class estimation for each colony in
%      the testing dataset, based on a pool among all the spectra from each
%      colony, and .colony_pool will contain the highest corresponding voting result.
%      To make things easier, .colony_codes will contain respective colony 
%      codes, because they are not directly obtained from the testing dataset
function out = est_new()

out.Y = [];
out.classes = [];
out.class_labels = {};

out.flag_per_colony = 0;

% Useful only if .flag_per_colony == 1
out.colony_codes = {};
out.colony_classes = [];
out.colony_maxpercs = [];
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
