% function out = est_new_from_model_data(model, data_test)
%
% Creates a new estimation structure with its fields already sized to match the
% data_test's number of observations and the model's number of outputs.
function out = est_new_from_model_data(model, data_test)

out = est_new();

no_observations = size(data_test.X, 1);

out.Y = zeros(no_observations, model_get_no_outputs(model));
out.classes = ones(no_observations, 1)*-1;
out.class_labels = model.class_labels;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
