% This routine extracts the wn X performance curves from o.cases
% The first curve is the curve from BM2
%
%   type: 'mean': performances for each case are averaged; 'hist': 
function curves = feasel_curves_from_logs(o, type)

curves = [];

%                 xx = {}; % wn
%                 yy = {}; % performance
j = 1;
i = 0;
len = 0;
for i = 1:length(o.logs)
    logg = o.logs(i);
    if length(logg.cases) > 0
        if logg.no_features <= 0
            error('Cannot generate curve from log because it does not have the same number of features for all cases');
        end;
        
        for j = 1:length(logg.cases)
            curves(i).idx(j) = logg.cases(j).idxs(logg.no_features);
            curves(i).performance(j) = mean(logg.cases(j).performances(:));
        end;
    end;
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
