% function dss = feasel_generate_dss(o)
function dss = feasel_generate_dss(o)

no_colonies = length(unique(o.ds.colony_codes));

if strcmp(o.validation_type, 'bootstrap')
    for i_rep = 1:o.no_reps
        idxs = randperm(no_colonies);
        cut_point = floor(no_colonies*o.perc_train);

        idxs_test = idxs(cut_point+1:end);
        idxs_train = idxs(1:cut_point);

        dss(i_rep).train = data_select_colonies(o.ds, idxs_train);
        dss(i_rep).test = data_select_colonies(o.ds, idxs_test);
    end;
else % crossval
    idxs_seq = 1:no_colonies;
    idxs_cross = crossvalind('kfold', no_colonies, o.no_reps);

    for i_rep = 1:o.no_reps
        idxs_test = idxs_seq(idxs_cross == i_rep);
        idxs_train = idxs_seq(idxs_cross ~= i_rep);

        dss(i_rep).train = data_select_colonies(o.ds, idxs_train);
        dss(i_rep).test = data_select_colonies(o.ds, idxs_test);
    end;
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
