% function M = feasel_get_performance_matrix(o)
%
% Better use this if you run feasel_go_exhaustive2(o) first
function M = feasel_get_performance_matrix(o)

nf = size(o.ds.X, 2);


M = zeros(nf, nf);

logg = o.logs(1);
if logg.no_features ~= 1
    error('First log should have number of features equal to one!');
end;
for i = 1:length(logg.cases)
    M(logg.cases(i).idxs, logg.cases(i).idxs) = mean(logg.cases(i).performances);
end;

logg = o.logs(2);
if logg.no_features ~= 2
    error('Second log should have number of features equal to two!');
end;
for i = 1:length(logg.cases)
    M(logg.cases(i).idxs(1), logg.cases(i).idxs(2)) = mean(logg.cases(i).performances);
    M(logg.cases(i).idxs(2), logg.cases(i).idxs(1)) = mean(logg.cases(i).performances);
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
