% function o = feasel_go_exhaustive2(o)
%
% special method for generating a classification surface
%
% It actually calls feasel_go_exhaustive twice
function o = feasel_go_exhaustive2(o)

nf = size(o.ds.X, 2);


stop_reason = 'none';

% Initialization of variables according to feature selection type
if o.flag_forward
%     nv = 0;
    idxs = [];
    direction = 1; % forward
else
%     nv = nf;
    idxs = 1:nf;
    direction = 0; % backward
end;


dss = feasel_generate_dss(o);


idxs_candidates = {};
for i = 1:nf
    idxs_candidates{i} = i;
end;

[o, logg] = feasel_validate(o, dss, idxs_candidates);
o.logs(1) = logg;



idxs_matrix = combnk(1:nf, 2);
no_candidates = size(idxs_matrix, 1);
idxs_candidates = {};
for i = 1:no_candidates
    idxs_candidates{end+1} = idxs_matrix(i, :);
end;


[o, logg] = feasel_validate(o, dss, idxs_candidates);
o.logs(2) = logg;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
