% function o = feasel_go_stepwise(o)
function o = feasel_go_stepwise(o)

nf = size(o.ds.X, 2);


stop_reason = 'none';

% Initialization of variables according to feature selection type
if o.flag_forward
%     nv = 0;
    idxs = [];
    direction = 1; % forward
else
%     nv = nf;
    idxs = 1:nf;
    direction = 0; % backward
end;





% % % % % % % % % % % % % % % % % % % % % % % % % % K-fold cross-validation initialization
% % % % % % % % % % % % % % % % % % % % % % % % % ms = o.ms;
% % % % % % % % % % % % % % % % % % % % % % % % % no_colonies = length(intersect(o.ds.colony_codes, o.ds.colony_codes));
% % % % % % % % % % % % % % % % % % % % % % % % % idxs_seq = 1:no_colonies;
% % % % % % % % % % % % % % % % % % % % % % % % % idxs_cross = crossvalind('kfold', no_colonies, o.crossval_no_reps);
% % % % % % % % % % % % % % % % % % % % % % % % % no_classes = length(ms.class_labels);
% % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % % history = [];
% % % % % % % % % % % % % % % % % % % % % % % % % cases = [];

% o.logs = [];


% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % makes all datasets a priori so things go quicker later
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % for i_rep = 1:o.crossval_no_reps
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %     idxs_test = idxs_seq(idxs_cross == i_rep);
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %     idxs_train = idxs_seq(idxs_cross ~= i_rep);
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % 
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %     dss(i_rep).train = data_select_colonies(o.ds, idxs_train);
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % %     dss(i_rep).test = data_select_colonies(o.ds, idxs_test);
% % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % % end;




dss = feasel_generate_dss(o);



i_cnt = 1;
while 1
    % First task is to include or exclude a variable
    if direction == 1
        if length(idxs) >= o.max_vars
            stop_reason = 'reached_max_vars';
            break;
        end;
        if length(idxs) == nf
            stop_reason = 'reached_nf';
            break;
        end;
        
        vtemp = 1:nf;
        vtemp(idxs) = []; % makes a vector with only the features not included so far
        
        idxs_candidates = cell(1, length(vtemp));
        for i = 1:length(vtemp)
            idxs_candidates{i} = [idxs vtemp(i)]; %sort([idxs vtemp(i)]);
        end;
    else
        if length(idxs) <= o.min_vars
            stop_reason = 'reached_min_vars';
            break;
        end;
        if length(idxs) == 1
            stop_reason = 'reached_1';
            break;
        end;
        
        idxs_candidates = cell(1, length(idxs));
        for i = 1:length(idxs)
            vtemp = idxs;
            vtemp(i) = [];
            idxs_candidates{i} = vtemp;
        end;
    end;

    

	fprintf('\n\n^^^^^^^^^^^^^^ Number of features: %d. ^^^^^^^^^^^^^^\n\n', length(idxs_candidates{1}));
    
    % Second task is to test every single feature list... oof, this gonna take time
    
    [o, logg] = feasel_validate(o, dss, idxs_candidates);
    o.logs(i_cnt) = logg;
    idxs = logg.cases(logg.idx_best).idxs;
    
    i_cnt = i_cnt+1;
    
% 	performances = zeros(1, length(idxs_candidates));
%     for i = 1:length(idxs_candidates)
%         fprintf('\n\n()()()()()()()() idxs candidate %d/%d. ()()()()()()()()\n\n', i, length(idxs_candidates));
%         ds_now = data_select_features(o.ds, idxs_candidates{i}, 'i');
%         
%         
% 
% %     modelset01 = modelset_boot(modelset01, ds_now);
% %     ms = modelset01;
% 
%         cc = zeros(no_classes, no_classes); % confusion matrix
%         for i_rep = 1:o.crossval_no_reps
%             fprintf('$*$*$*$ Session %d/%d. $*$*$*$\n', i_rep, o.crossval_no_reps);
%             ms = modelset_boot(ms, ds_now);
%             ms = modelset_boot(ms, ds_now);
% 
% %             idxs_test = idxs_seq(idxs_cross == i_rep);
% %             idxs_train = idxs_seq(idxs_cross ~= i_rep);
% 
%             d_train = data_select_features(dss(i_rep).train, idxs_candidates{i}, 'i'); %data_select_colonies(ds_now, idxs_train);
%             d_test = data_select_features(dss(i_rep).test, idxs_candidates{i}, 'i'); %ata_select_colonies(ds_now, idxs_test);
% 
%             ms = modelset_train(ms, d_train);
%             ms = modelset_estimate(ms, d_test);
%             cc = cc+est_get_confusion(ms.o_est, d_test, 0);
%         end;
% 
%         ssp = calc_sens_spec(cc);
%         performances(i) = mean(ssp(:)); % mean of all sensitivities and specificities
%         
%         cases(end+1).performance = performances(i);
%         cases(end).idxs = idxs_candidates{i};
%     end;
%     
%     
%     [val, idx] = max(performances);
%     
%     idxs = idxs_candidates{idx};
%     history(end+1).performance = val;
%     history(end).idxs = idxs;
end;


o.stop_reason = stop_reason;
% o.history = history;
% o.cases = cases;
% o.idxs = idxs;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
