% function format_wn(par)
%
% Inputs:
%
%   par: either a data structure or the [x1, x2] range, for ex., [2000, 400], or even the x-values themselves like a
%        data.x
% Reverses axes and puts X limits between 900 and 1800
function format_wn(par)

if exist('par', 'var')
    if isstruct(par)
        x1 = par.x(1);
        x2 = par.x(end);
    else
        x1 = par(1);
        x2 = par(end);
    end;
else
    % Default OPUS range
    x1 = 1801.47;
    x2 = 898.81;
end;

if x1 > x2
    set(gca, 'XDir', 'reverse');
    set(gca, 'Xlim', [x2, x1]);
else
    set(gca, 'Xlim', [x1, x2]);
end;

xlabel('Wavenumber (cm^{-1})');
ylabel('Absorbance (a.u.)');




% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
