disp('This program performs stepwise forward feature selection to determine')
disp('the best few wavenumbers for classification, aiming to interpret these')
disp('as biomarkers');

% % % % % % addpath('../summer');
% % % % % % load_current_dataset();
% % % % % % colors_markers();
% % % % % % 
% % % % % % nf = size(dswork.X, 2);
% % % % % % 
% % % % % % a_options = {'Agent vs. vehicle control', 'Non-transformed vs. Transformed per tray', 'Non-transformed vs. Transformed overall'};

%%

colors_markers();




while 1
    clc;
    if exist('datasets')
        disp('|| Datasets:')
        for i = 1:length(datasets)
            disp(datasets(i).name);
        end;
    end;
    
    if exist('results')
        disp('|| Results:')
        for i = 1:length(results.items)
            if ~isempty(results.items(i).lines(1).y);
                fprintf(' *BM1line* ');
            end;
            if ~isempty(results.items(i).lines(2).y);
                fprintf(' *BM2line* ');
            end;
            if ~isempty(results.items(i).bm2_surface);
                fprintf(' *BM2surface* ');
            end;
            if ~isempty(results.items(i).lines(3).y);
                fprintf(' *BM3* ');
            end;
            if ~isempty(results.items(i).sfs_best_rates);
                fprintf(' *SFS* ');
            end;
            fprintf('\n');
        end;
    end;
    
    
    option = menu('Main menu', {'Mount datasets', 'Select datasets', 'Run session ', 'Visualize results', 'Trim results', 'Save results', 'Load results'}, 'End');
    if option == 0
        return;
    elseif option == 1
        dsinput_name = input('Input dataset name: ', 's');
        if ~isempty(dsinput_name)
            dswork = eval(dsinput_name);
        
            option2 = menu('Dataset split type', {'Hierarchical', 'Agent vs. VC', 'None'}, 'Cancel');
            if option2 == 1
                levels_main = input('Main level(s) (example: [1]): ');
                if ~isempty(levels_main)
                    clear datasets;
                    pieces = data_split_classes(dswork, levels_main);
                    for i = 1:length(pieces)
                        datasets(i).data = pieces(i);
                        dtemp = data_select_hierarchy(datasets(i).data, levels_main);
                        datasets(i).name =  dtemp.class_labels{1};
                    end;
                end;
            elseif option2 == 2
                idx_vc = input('Vehicle control class index (example: 1): ');
                if ~isempty(idx_vc)
                    clear datasets;
                
                    pieces = data_split_classes(dswork);
                    ii = 0;
                    for i = 1:length(pieces)
                        if i ~= idx_vc
                            ii = ii+1;
                            datasets(ii).data = data_merge(pieces([idx_vc, i]));
                            datasets(ii).name = ['\begin{bf}' pieces(i).class_labels{1} ' \begin{it}vs.\end{it} ' pieces(idx_vc).class_labels{1} '\end{bf}'];
                        end;
                    end;
                end;
            elseif option2 == 3
                clear datasets;
               datasets(1).data = dswork;
               datasets(1).name = 'All';
            end;
        end;
    elseif option == 2
        idxs = input('Type the indexes of the datasets to be kept ([1, 2, ...]): ');
        if ~isempty(idxs)
            datasets = datasets(idxs);
        end;
    elseif option == 3
        if ~exist('bm2_no_vars', 'var')
            bm2_no_vars = 1;
        end;
        if ~exist('bm2_k', 'var')
            bm2_k = 10;
        end;
        if ~exist('bm3_max_vars', 'var')
            bm3_max_vars = 3;
        end;
        if ~exist('bm3_no_reps', 'var')
            bm3_no_reps = 833;
        end;
        if ~exist('sfs_max_vars', 'var')
           sfs_max_vars = 5;
        end;
        if ~exist('sfs_k', 'var')
           sfs_k = 50;
        end;
        if ~exist('methods_selected', 'var')
            methods_selected = [1, 2, 3];
        end;

        while 1
            clc;
%             fprintf('|| Selected methods\n');
            s = '';
            method_names = {'BM1', 'BM2', 'BM3', 'SFS'};
            for i = 1:length(methods_selected)
                if i > 1
                    s = [s ', '];
                end;
                s = [s method_names{methods_selected(i)}];
            end;
%             
%                 
%             fprintf([ ...
%             '|| Parameters\n' ...
%             'BM2 numbers of variables:        %d\n' ...
%             'BM2 k (k-fold cross-validation): %d\n' ...
%             'BM3 top number of variables:     %d\n' ...
%             'BM3 number of bootstraps:        %d\n' ...
%             'SFS top number of variables:     %d\n' ...
%             'SFS k (k-fold cross-validation): %d\n\n' ...
%             ], bm2_no_vars, bm2_k, bm3_max_vars, bm3_no_reps, sfs_max_vars, sfs_k);


            option2 = menu('Run session menu', { ...
            'Help', ...
            sprintf('Methods:                          %s', s), ...
            sprintf('BM2 numbers of variables:         %d', bm2_no_vars), ...
            sprintf('BM2 k (k-fold cross-validation):  %d', bm2_k), ...
            sprintf('BM3 top number of variables:      %d', bm3_max_vars), ...
            sprintf('BM3 number of bootstraps:         %d', bm3_no_reps), ...
            sprintf('SFS top number of variables:      %d', sfs_max_vars), ...
            sprintf('SFS: k (k-fold cross-validation): %d', sfs_k), ...
            'Go!' ...
            }, 'Back');


            if option2 == 0
                break;
            elseif option2 == 1
                clc;
                fprintf([...        
                'Classification Rate Curves (BM2)\n' ...
                '--------------------------------\n' ...
                'All wavenumbers (or all possible combinations of 2 \n' ...
                'or more wavenumbers) are assessed for their \n' ...
                'classification power using a classification method.\n' ...
                'Result is a\n' ...
                '  . [wn]x[classification rate] curve \n' ...
                '    (1 wavenumber) or a \n' ...
                '  . [wn1]x[wn2]x[classification rate] curve \n' ...
                '    (2 wavenumbers) \n' ...
                'Currently cross-validation is being used for\n' ...
                'validation.\n' ...
                '\n' ...
                'Best Wavenumbers Histogram (BM3)\n' ...
                '--------------------------------\n' ...
                'Forward stepwise feature selection is used up to a\n' ...
                'certaing number of wavenumbers, using a given \n' ...
                'classifier classification rate over a training, \n' ...
                'test dataset pair. Then the wavenumbers found "hit \n' ...
                'the bins" of a histogram where each bin represents \n'...
                'one of the possible wavenumbers. The process is \n' ...
                'repeated several times using the bootstrap method \n' ...
                '(random split of the dataset into training and test \n' ...
                'sets), thus allowing the most frequently choosen \n' ...
                'wavenumbers to emerge. The more bootstrap \n' ...
                'repetitions, the more precise is the generated \n' ...
                'histogram.\n' ...
                '\n' ...
                'Stepwise feature selection (SFS)\n' ...
                '--------------------------------\n' ...
                'Forward stepwise feature selection is used up to a\n' ...
                'certaing number of wavenumbers, using an \n' ...
                'average classifier classification rate over a, \n' ...
                'set of training, test dataset pairs, which are\n'...
                'obtained through cross-validation.\n\n' ...
                ]);
                input('--- PAUSE ---');
            elseif option2 == 2
                temp = menu('Select methods', {'BM1: differences between mean curves', 'BM2: classification rate curve/surface', 'BM3: best wavenumbers histogram', 'SFS: Stepwise forward feature selection'}, 'Nevermind');
                if sum(temp == 0) == 0
                    methods_selected = temp;
                end;
                
            elseif option2 == 3
                while 1
                    temp = input('Enter BM2 numbers of variables (1 or 2): ');

                    if isempty(temp)
                        break;
                    elseif ~(temp == 1 || temp == 2)
                        fprintf('1 or 2, please.\n');
                    else
                        bm2_no_vars = temp;
                        break;
                    end;
                end;
                
            elseif option2 == 4
                while 1
                    temp = input('BM2 k (k-fold cross-validation): ');

                    if isempty(temp)
                        break;
                    elseif ~(temp == floor(temp)) || temp <= 1
                        fprintf('Please enter an integer value > 1.\n');
                    else
                        bm2_k = temp;
                        break;
                    end;
                end;
                
            elseif option2 == 5
                while 1
                    temp = input('BM3 top number of variables: ');

                    if isempty(temp)
                        break;
                    elseif ~(temp == floor(temp)) || temp <= 0
                        fprintf('Greater than zero integer value, please.\n');
                    else
                        bm3_max_vars = temp;
                        break;
                    end;
                end;
                
            elseif option2 == 6
                while 1
                    temp = input('BM3 number of bootstraps: ');

                    if isempty(temp)
                        break;
                    elseif ~(temp == floor(temp)) || temp <= 0
                        fprintf('Greater than zero integer value, please.\n');
                    else
                        bm3_no_reps = temp;
                        break;
                    end;
                end;

            elseif option2 == 7
                while 1
                    temp = input('SFS top number of variables: ');

                    if isempty(temp)
                        break;
                    elseif ~(temp == floor(temp)) || temp <= 0
                        fprintf('Greater than zero integer value, please.\n');
                    else
                        sfs_max_vars = temp;
                        break;
                    end;
                end;

            elseif option2 == 8
                while 1
                    temp = input('SFS k (k-fold cross-validation): ');

                    if isempty(temp)
                        break;
                    elseif ~(temp == floor(temp)) || temp <= 0
                        fprintf('Greater than zero integer value, please.\n');
                    else
                        sfs_k = temp;
                        break;
                    end;
                end;

            elseif option2 == 9
                
                %-*%-*%-*%-*%-*
                %-*%-*%-*%-*%-*
                %-*%-*%-*%-*%-*
                %-*%-*%-*%-*%-*
                %-*%-*%-*%-*%-*
                %-*%-*%-*%-*%-*
                %-*%-*%-*%-*%-*
                
                
                clear results;
                no_datasets = length(datasets);


                results = bmresults_new();
                results.indicator_y = mean(datasets(1).data.X);
                results.x = datasets(1).data.x;         
                results.legends = {'BM1', 'BM2', 'BM3'};
                
                for i = 1:no_datasets

                    results.items(i) = bmresult_new();
                    results.items(i).lines = repmat(bmresultline_new(), 1, 3);
                    results.items(i).name = datasets(i).name;
                    results.items(i).x = results.x;
                    
                    o = bmresultline_new();                    
                    results.items(i).lines(1) = o;
                    results.items(i).lines(2) = o;
                    results.items(i).lines(3) = o;

                    if ~isempty(intersect(methods_selected, [2, 3, 4]))
                        modelset01 = modelset_new(@cla_new, 0);
                        modelset01 = modelset_create_models(modelset01, datasets(i).data);
                        modelset01 = modelset_setbatch(modelset01, {'type', 'linear', ...
                        'flag_class2mo', 1});
                    end;
                    

                    if sum(methods_selected == 1) > 0
                        
                        %-*%-*%-*%-*%-*
                        %-*%-*%-*%-*%-* BM1
                        %-*%-*%-*%-*%-*
                        
                        pieces = data_split_classes(datasets(i).data);
                        results.items(i).lines(1).y = mean(pieces(2).X)-mean(pieces(1).X);
                    end;

                    if sum(methods_selected == 2) > 0
                        
                        %-*%-*%-*%-*%-*
                        %-*%-*%-*%-*%-* BM2
                        %-*%-*%-*%-*%-*

                        
%                        modelset01 = modelset_new(@cla_new, 0);
%                        modelset01 = modelset_create_models(modelset01, datasets(i).data);
%                        modelset01 = modelset_setbatch(modelset01, {'type', 'linear', ...
%                        'flag_class2mo', 1});

                        modelset01 = modelset_boot(modelset01, datasets(1).data);


                        o = feasel_new();
                        o.ms = modelset01;
                        o.no_reps = bm2_k;
                        o.flag_forward = 0;

                        o.ds = datasets(i).data;

                        if bm2_no_vars == 1
                            o = feasel_go_exhaustive(o, 1);
                            results.items(i).lines(2).y = feasel_get_features_ranking(o)*100;
                        else
                            o = feasel_go_exhaustive2(o);
                            results.items(i).bm2_surface = feasel_get_performance_matrix(o);
                        end;
                        
                    end;

                    if sum(methods_selected == 3) > 0

                        %-*%-*%-*%-*%-*
                        %-*%-*%-*%-*%-* BM3
                        %-*%-*%-*%-*%-*

                        
%                        modelset01 = modelset_new(@cla_new, 0);
%                        modelset01 = modelset_create_models(modelset01, datasets(i).data);
%                        modelset01 = modelset_setbatch(modelset01, {'type', 'linear', ...
%                        'flag_class2mo', 1});

                        results.items(i).lines(3).y = build_bm3_histogram(datasets(i).data, modelset01, bm3_max_vars, 0.9, bm3_no_reps);

                    end;

                    if sum(methods_selected == 4) > 0
                        
                        %-*%-*%-*%-*%-*
                        %-*%-*%-*%-*%-* SFS
                        %-*%-*%-*%-*%-*

                        
%                        modelset01 = modelset_new(@cla_new, 0);
%                        modelset01 = modelset_create_models(modelset01, datasets(i).data);
%                        modelset01 = modelset_setbatch(modelset01, {'type', 'linear', ...
%                        'flag_class2mo', 1});


%                        results.items(i) = bmresult_go_sfs(results.items(i), datasets(i).data, modelset01, sfs_k, sfs_max_vars);
                        

                        o = feasel_new();
                        o.ms = modelset01;
                        o.no_reps = sfs_k;
                        o.min_vars = 1;
                        o.max_vars = sfs_max_vars;
                        o.flag_forward = 1;

                        o.ds = datasets(i).data;
                        o = feasel_go_stepwise(o);

                        for j = 1:length(o.logs)
                            logg = o.logs(j);
                            results.items(i).sfs_best_rates(j) = mean(logg.cases(logg.idx_best).performances);
                        end;
                        results.items(i).sfs_idxs_best_final = o.logs(end).cases(o.logs(end).idx_best).idxs;
                        results.items(i).sfs_evolution = feasel_curves_from_cases(o);
                    end;
                end;

                pause2();
            
            end;
        end;

                
    elseif option == 4
        if ~exist('results', 'var')
            disp('No results stored!');
            pause2();
            continue;
        end;
        
        while 1
            clc;
            option2 = menu('Visualization', {...
            'BM1: difference between means curves', ...
            'BM2: classification rate curve', ...
            'BM2: classification rate surface', ...
            'BM3: best wavenumbers histogram', ...
            'SFS: [#wn]x[best average classification rate]', ...
            'SFS: evolution', ...
            'Mixed: biomarkers', ...
            'Mixed: BM1, BM2 and BM3 curves' ...
            }, 'Back');

            if option2 == 0
                break;
            elseif option2 == 1
                % Difference between means curves
                
                figure;
                legends = {};
                hh = [];
                draw_zero_line(results.x);
                hold on;
                plot_indicator_spectrum(results.x, results.indicator_y/max(results.indicator_y)*.08);
                % maxmax = 0;
                for i = 1:length(results.items)
                    hh(end+1) = plot(results.x, results.items(i).lines(1).y, 'Color', find_color(i), 'LineWidth', 3);
                    legends{end+1} = ['\begin{bf}' results.items(i).name '\end{bf}'];
                end;
                legend(hh, legends, 'Interpreter', 'latex');
                format_wn(results.x);
                format_frank(gcf);
                title('BM1: Differences between means curves');
                
            elseif option2 == 2
                % Classification rate curve


                figure;
                legends = {};
                hh = [];
                draw_zero_line(results.x);
                hold on;
                plot_indicator_spectrum(results.x, results.indicator_y/max(results.indicator_y)*80);
                
                for i = 1:length(results.items)
                    hh(end+1) = plot(results.x, results.items(i).lines(2).y, 'Color', find_color(i), 'LineWidth', 3);
%                         title(['\begin{bf}' results.items(i).name '\end{bf}'], 'Interpreter', 'latex');
                    legends{end+1} = ['\begin{bf}' results.items(i).name '\end{bf}'];
                end;

                legend(hh, legends, 'Interpreter', 'latex');
                ylabel('Classification rate (%)');
                format_wn(results.x);
                format_frank(gcf);
                title('BM2: classification rates curves');
                
            elseif option2 == 3
                % Classification rate surface

                if isempty(results.items(1).bm2_surface)
                    disp('No BM2 classification surface in the results!');
                    pause2();
                    continue;
                end;
                
                flag_ok = 1;
                if length(results.items) > 1
                    idx = input('Enter the result index: ');
                    if isempty(idx)
                        flag_ok = 0;
                    end;
                else
                    idx = 1;
                end;


                if flag_ok
                    % maxmax = 0;
                    for i = idx:idx
                        figure;
                        draw_covariance(results.items(i).bm2_surface*100, results.x, results.indicator_y);
                        title(['\begin{bf}' results.items(i).name '\end{bf}'], 'Interpreter', 'latex');
                        colorbar;
                        format_frank(gcf);
                    end;
                end;
            elseif option2 == 4
                if isempty(results.items(1).lines(3).y)
                    disp('No BM3 curve in the results!');
                    pause2();
                    continue;
                end;

                
                
                if length(results.items) > 1
                    i_dataset = input(sprintf('Which dataset do you want to see the results for (1-%d)? ', length(results.items)));
                else
                    i_dataset = 1;
                end;
                
                if ~isempty(i_dataset)
                    figure; 
                    plot(results.x, results.items(i_dataset).lines(3).y); 
                    title(['\begin{bf}' results.items(i_dataset).name '\end{bf}'], 'Interpreter', 'latex');
                    format_wn; 
                    ylabel('Hit count');
                    format_frank;
                end;
                
                
            elseif option2 == 5                
                % Plots the classification rate versus the number of wavenumbers
                figure;
                hh = [];
                for i = 1:length(results.items)
                    hh(i) = plot(results.items(i).sfs_best_rates*100, 'LineWidth', 5, 'Color', find_color(i));
                    hold on;
                end;

                xlabel('Number of variables');
                ylabel('Classification rate (%)');
                legend(hh, {results.items.name});
                format_frank(gcf, 1.8);
                
            elseif option2 == 6
                % Evolution
                flag_ok = 1;
                if length(results.items) > 1
                    idx = input('Enter the result index to see the evolution: ');
                    if isempty(idx)
                        flag_ok = 0;
                    end;
                else
                    idx = 1;
                end;
%                 x = results.items(idx).x;
%                 o = ;
                

                curves = results.items(idx).sfs_evolution;
                
                np = length(curves);
                figure;
                for i = 1:np
                    subplot(np, 1, i);
                    x = results.items(idx).x(curves(i).idx);
                    y = curves(i).performance;
                    plot_curve_pieces(x, y);
                    [va, in] = max(y);
                    hold on;
                    plot(x(in), y(in), 'rx');
                    set(gca, 'XDir', 'reverse');
                    if i == 1
                        title('None before');
                    else
                        wn = results.x(results.items(idx).sfs_idxs_best_final(i-1));
                        title(sprintf('%4.0f added', wn));
                    end;
                end;
                    
                
            elseif option2 == 7
                % ^^^^  (o) ^ (o)  ^^^^ -------------- biomarker balls
                interactive_feasel_for_biomarkers_setuplines;
                
                figure;

                no_markers = 5;

                xy = [];
                flag_bm1 = 0;
                legends = {};
                for i = 1:length(results.items)
                    
                    results.items(i) = bmresult_intersect(results.items(i), 5);
                end;
                
%                 set(gca, 'Interpreter', 'TeX');
                bmresults_draw_markers(results, 0);
                
%                 legends = {'Univariate classification rate (BM2)', 'Best jointly distinguishing wavenumbers (BM3)'};
%                 if flag_bm1
%                     legends = {'Difference between means (BM1)', legends{1}, legends{2}};
%                 end;
%                 legend(hh, legends);
            elseif option2 == 8
                flag_ok = 1;
                if length(results.items) > 1
                    idx = input('Enter the result index to see curves: ');
                    if isempty(idx)
                        flag_ok = 0;
                    end;
                else
                    idx = 1;
                end;

                if flag_ok
                    interactive_feasel_for_biomarkers_setuplines;

                                    
                    figure;
                    results.items(idx) = bmresult_intersect(results.items(idx), 5);
                    results = bmresults_calculate_drawlines(results);
                    bmresult_draw_lines(results.items(idx), results);
                    title(['\begin{bf}' results.items(idx).name '\end{bf}'], 'Interpreter', 'latex');
                end;
                
%                 Thursday
                
                
            end;
        end;
        
    elseif option == 5  %---------------------------------------- TRIM
        if ~exist('results', 'var')
            disp('No results stored!');
            pause2();
            continue;
        end;
        
        fprintf('Current wavenumber range is [%f, %f].\n', results.x(1), results.x(end));
        flag_change = 0;
        while 1
            range_new = input('Enter new range ([wn1, wn2]): ');
            
            if isempty(range_new)
                break;
            end;
                        
            ii = v_x2ind(range_new, results.x);
            if sum(ii < 1)  > 0 || sum(ii > length(results.x)) > 0
                disp('Invalid range!');
            else
                flag_change = 1;
                break;
                
            end;
        end;
            
        if flag_change
            idxs = ii(1):ii(end);
            results.x = results.x(idxs);


            for i = 1:length(results.items)
                if ~isempty(results.items(i).lines(1).y)
                    results.items(i).lines(1).y = results.items(i).lines(1).y(idxs);
                end;
                if ~isempty(results.items(i).lines(2).y)
                    results.items(i).lines(2).y = results.items(i).lines(2).y(idxs);
                end;
                if ~isempty(results.items(i).bm2_surface)
                    results.items(i).bm2_surface = results.items(i).bmsurface(idxs, idxs);
                end;
                if ~isempty(results.items(i).lines(3).y)
                    results.items(i).lines(3).y = results.items(i).lines(3).y(idxs);
                end;
                if ~isempty(results.items(i).sfs_evolution)
                    for i_ev = 1:length(results.items(i).sfs_evolution)
                        idxsout = or(results.items(i).sfs_evolution(i_ev).idx < idxs(1), results.items(i).sfs_evolution(i_ev).idx > idxs(end));
                        results.items(i).sfs_evolution(i_ev).idx(idxsout) = [];
                        results.items(i).sfs_evolution(i_ev).performance(idxsout) = [];
                    end;
                end;
                if ~isempty(results.items(i).x)
                    results.items(i).x = results.items(i).x(:, idxs);
                end;
            end;
            pause2();
        end;

        
    elseif option == 6
        filename = input('Type file name to save: ', 's');
        if ~isempty(filename)
            save(filename, 'results');
        end;
    elseif option == 7
        filename = input('Type file name to load: ', 's');
        if ~isempty(filename)
            load(filename);
        end;
    end;        
end;


% % % % option = menu('Select the desired test', ...
% % % % a_options, 'cancel');
% % % % if option == 0
% % % %     return;
% % % % % % end;




% % % % % % % % % % % clear datasets dataset_names;
% % % % % % % % % % % 
% % % % % % % % % % % if option == 1 % Agent vs. VC
% % % % % % % % % % %     dswork = data_select_hierarchy(dswork, 1);
% % % % % % % % % % %     pieces = data_split_classes(dswork);
% % % % % % % % % % %     tray_ref = 1; % DMSO: Control
% % % % % % % % % % % 
% % % % % % % % % % %     ii = 0;
% % % % % % % % % % %     for i = 1:length(pieces)
% % % % % % % % % % %         if i ~= tray_ref
% % % % % % % % % % %             ii = ii+1;
% % % % % % % % % % %             datasets(ii) = data_merge(pieces([tray_ref, i]));
% % % % % % % % % % %             dataset_names{ii} = ['VC vs. ' pieces(tray_ref).class_labels{1}];
% % % % % % % % % % %         end;
% % % % % % % % % % %     end;
% % % % % % % % % % % 
% % % % % % % % % % % elseif option == 2 % N vs. T per tray
% % % % % % % % % % %     pieces0 = data_split_classes(dswork);
% % % % % % % % % % %     for i = 1:8
% % % % % % % % % % %         datasets(i) = data_merge(pieces0((i-1)*2+[1, 2]));
% % % % % % % % % % %         dtemp = data_select_hierarchy(datasets(i), 1);
% % % % % % % % % % %         dataset_names{i} =  dtemp.class_labels{1};
% % % % % % % % % % %     end;
% % % % % % % % % % % 
% % % % % % % % % % % elseif option == 3 % n vs. t overall
% % % % % % % % % % %    datasets = data_select_hierarchy(dswork, 2);
% % % % % % % % % % %    dataset_names = {'N vs. T all'};
% % % % % % % % % % % 
% % % % % % % % % % % end;
% % % % % % % % % % % no_datasets = length(datasets);
% % % % % % % % % % % 






% % % % % % % %%
% % % % % % % 
% % % % % % % rt = cell(no_datasets+1, 2);
% % % % % % % rt{1, 1} = a_options{option};
% % % % % % % 
% % % % % % % idxss = zeros(no_datasets, max_vars);
% % % % % % % 
% % % % % % % for i = 1:no_datasets
% % % % % % %     davez = datasets(i);
% % % % % % %     
% % % % % % %     modelset01 = modelset_new(@cla_new, 0);
% % % % % % %     modelset01 = modelset_create_models(modelset01, davez);
% % % % % % %     modelset01 = modelset_setbatch(modelset01, {'type', 'linear', ...
% % % % % % %     'flag_class2mo', 1});
% % % % % % %     modelset01 = modelset_boot(modelset01, dswork);
% % % % % % % 
% % % % % % % 
% % % % % % %     o = feasel_new();
% % % % % % %     o.ms = modelset01;
% % % % % % %     o.max_vars = max_vars;
% % % % % % %     o.crossval_no_reps = 2;
% % % % % % %     o.min_vars = 1;
% % % % % % %     o.flag_forward = 1;
% % % % % % %     
% % % % % % %     o.ds = davez;
% % % % % % %     
% % % % % % %     o = feasel_go_stepwise(o);
% % % % % % %     
% % % % % % %     rt(i+1, 1:2) = {dataset_names{i}, mat2str(round(davez.x(o.idxs)*10)/10)};
% % % % % % %     idxss(i, :) = davez.x(o.idxs);
% % % % % % % end;
% % % % % % % 
%%

% % % % % % % % Plots the classification rate versus the number of wavenumbers
% % % % % % % 
% % % % % % % figure;
% % % % % % % plot([o.history.performance]*100, 'LineWidth', 5);
% % % % % % % xlabel('Number of variables');
% % % % % % % ylabel('Classification rate (%)');
% % % % % % % format_frank(gcf, 1.8);
% % % % % % % 
% % % % % % % 
% % % % % % % %%
% % % % % % % 
% % % % % % % % Plots the biomarker balls
% % % % % % % 
% % % % % % % figure;
% % % % % % % draw_markers(idxss, dataset_names, [], dswork, 1);
% % % % % % % 
% % % % % % % 
% % % % % % % %%
% % % % % % % save('warforterritory', 'rt');
% % % % % % % save_txt_file(csv_from_cell(rt), find_filename(['warforterritory_' a_options{option}], '', 'txt'));

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
