% function out = knn_new(name)
%
% Creates a new k- Nearest Neighbours (k-NN) Model
%
% Inputs:
%   name: string containing a name for the model (optional)
%
% Outputs:
%   out: the model
function out = knn_new(name)

if exist('name', 'var')
    name = 'k-NN Model';
end;
out = model_new(name);

%%%
% General fields
out.important_prop_names = {'time_estimate'};
out.important_prop_descriptions = {'Testing time (seconds)'};


out.f_train = 'knn_train'; % function that will train the model
out.f_test = 'knn_estimate'; % function that will train the model
out.f_boot = 'knn_boot'; % function that will boot the model. Usually not changed.

out.k = 1; % Default k for k-NN

%%%
% Fields specific to k-NN

% Training data is part of the model in the k-NN algorithm
out.X = []; 
out.classes = [];

out.flag_class2mo = 0; % 1 does not make sense in k-nn
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
