% function option = menu(title, options, cancel_label)
function option = menu(title, options, cancel_label)

no_options = length(options);

flag_ok = 0;
ch = 'O';
while 1
    fprintf('\n');
    fprintf(['  ' ch*ones(1, length(title)+8) '\n']);
    fprintf(['  ' ch*ones(1, 3) ' ' title ' ' ch*ones(1, 3) '\n']);
    fprintf(['  ' ch*ones(1, length(title)+8) '\n']);
    for i = 1:no_options
        fprintf('  %d - %s\n', i, options{i});
    end;
    fprintf('  0 - << (*%s*)\n', cancel_label);
    option = input('% ');
    
    n_try = 0;
    while 1
        if n_try >= 10
            fprintf('You are messing up');
            break;
        end;
        
        flag_no = 0;
        for i = 1:length(option)
            if option(i) < 0 || option(i) > no_options
                flag_no = 1;
                break;
            end;
        end;
        if ~flag_no
            flag_ok = 1;
            break;
        end;
        
        fprintf('Invalid option, range is [%d, %d].', 0, no_options);
            
        n_try = n_try+1;
        option = input('% ');
        

    end;
    
    if flag_ok
        break;
    end;
end;


% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
