% function mm = mf_gauss(X, centers, radii)
%
% Inputs:
%   X: [1][no_features] data point
%   centers: [no_rules][no_features]
%   radii: [no_rules][no_features]
%
% Output:
%   mm: [no_rules][no_features]
function mm = mf_gauss(X, centers, radii)
[no_rules, no_features] = size(centers);
mm = zeros(no_rules, no_features);
for i = 1:no_rules
    mm(i, :) = exp(-(X-centers(i, :)).^2./(2*radii(i, :).^2));
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
