% function [model, est] = mnr_estimate(model, data)
%
% Outputs:
%   model: the model itself
%   est: estimation structure
% Matlab's classify() does everything at once, training and testing. This will obviously compromise time measures.
function [model, est] = mnr_estimate(model, data)
est = est_new_from_model_data(model, data);
tic();

% est.classes = classify(data.X, model.X, model.classes, model.type);
PHAT = mnrval(model.mnrmodel, data.X);
[values, indexes] = max(PHAT, [], 2);
est.classes = indexes-1;
est.Y = est.classes;
model.time_estimate = toc();

est.rate = est_get_rate(est, data);

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
