% function data = modelset_prepare_data(o, data)
%
% This function uses modelset parameters to pre-process and transform data,
% depending on how some flags of the modelset have been configured
function [a, data] = modelset_prepare_data(a, data)

if a.flag_preprocess
    a.preprocess_means = mean(data.X, 1);
    a.preprocess_stds = std(data.X, 1);
    data = data_normalize(data, a.preprocess_type);
end;

if a.flag_transform
    data = a.transform_fcn(data);
    a.transform_L = data.L;
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
