% Z = peak_db(x = None)
% 
% Returns a table with substance names, peak centres and closest indexes in
% x, if x is provided.
%
%
function Z = peak_db(x)

Z.names = {'lipid',
           'amide I', 
           'amide II', 
           'proteins?', 
           'proteins', 
           'COO- symmetric stretching vibrations of fatty acids and amino acid', 
           'amide III', 
           'asymmetric phosphate', 
           'carbohidrate', 
           'C-O stretch (nu CO)'
           'symmetric phosphate', 
           'glycogen',
           'protein phosphorylation'};
Z.centres = [
    1750, 
    1635, 
    1531, 
    1454, 
    1425, 
    1396, 
    1260, 
    1225,
    1155, 
    1140, 
    1080, 
    1030, 
     970];

if exist('x')
    no = length(Z.centres);
    no_x = length(x);
    Z.indexes = zeros(1, no);
    
    for i = 1:no
        for j = 1:no_x
            if Z.centres(i) > x(j)
               
                % Checks which point is closest, if current or last one.
                if j == 1
                    Z.indexes(i) = j;
                elseif Z.centres(i)-x(j) < x(j-1)-Z.centres(i)
                    Z.indexes(i) = j;
                else
                    Z.indexes(i) = j-1;
                end;
                break;
            end;
        end;
        if Z.indexes(i) == 0
            Z.indexes(i) = no_x;
        end;
    end;
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
