%
% Arguments:
%   I is integrate(X)
%   map: [idxmin, idxmax, flag_min; ...]
%   t_range: for the final conversion of T's values to the proper scale.
function T = peak_landmarks(X, map, t_range)

[no, no_t] = size(X);

if ~exist('t_range', 'var')
    t_range = [1, no_t];
end;


no_peaks = size(map, 1);
T = zeros(no, no_peaks);
for i = 1:no
    v = X(i, :);
    
    for j = 1:no_peaks
        idxs = map(j, 1):map(j, 2);
        flag_min = map(j, 3);
        
        if flag_min
            [val, idx_peak] = min(v(idxs));
        else
            [val, idx_peak] = max(v(idxs));
        end;
        idx_peak = idx_peak+idxs(1)-1;
        
        T(i, j) = idx_peak;
    end;
end;
    
tf = t_range(2);
ti = t_range(1);

T = (T-1)*(tf-ti)/(no_t-1)+ti; % Normalizes warping information to the original number of features




% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
