% handles{} = plot_curve_pieces(x, y, varargin)
% 
% Mimics the plot() function, but does several plots if x does not
% have the same increment step.
function h = plot_curve_pieces(x, y, varargin)

dist_difference_tolerance = 1.2*abs(mean(diff(x))); % distance difference tolerance

no_points = length(x);
i = 1;
no_plots = 0;
while 1
    flag_break = i > no_points;
    flag_plot = 0;
    flag_new_piece = 0;
    
    if flag_break
        flag_plot = 1;
    else
        if i == 1
            flag_new_piece = 1;
        else
            dist = abs(x(i)-x(i-1));

            if i-piece_start > 1 && dist-dist_old > dist_difference_tolerance
                flag_plot = 1;
                flag_new_piece = 1;
            end;
        end;
    end;

    if flag_plot
        no_plots = no_plots+1;
        h{no_plots} = plot(x(piece_start:i-1), y(piece_start:i-1), varargin{:});
        hold on;
    end;
    
    if flag_break
        break;
    end;
    
    if flag_new_piece
        piece_start = i;
    end;
    
    if i > 1
        dist_old = dist;
    end;
    i = i+1;
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
