% print_peaks(x, y, threshold)
%
% Plots x's and annotates wavenumbers
%
% Inputs;
%   x: vector of wavenumbers
%   y: vector of amplitudes
%   threshold: minimum amplitude to be considered
function plot_peaks(x, y, threshold)

scale = max(abs(y));
offset = 0.025*scale;

peak_indexes = detect_peaks(y, threshold);
x_peaks = x(peak_indexes);
y_peaks = y(peak_indexes);

plot(x_peaks, y_peaks, 'kx');
hold on;
for i = 1:length(x_peaks)
    offset = 0.025*scale;
    if y_peaks(i) < 0
        offset = -offset;
    end;
    
    text(x_peaks(i), y_peaks(i)+offset, sprintf('%.0f', x(peak_indexes(i))), 'FontName', 'Times New Roman', 'FontSize', 21);
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
