% print_peaks(x, y, threshold)
%
% Prints a peak report
%
% Inputs;
%   x: vector of wavenumbers
%   y: vector of amplitudes
%   threshold: minimum amplitude to be considered
function print_peaks(x, y, threshold)

db = peak_db(x);

peak_indexes = detect_peaks(y, threshold);
for i = 1:length(peak_indexes)
    ic = peak_closest(db, peak_indexes(i));
    s = db.names{ic};
    fprintf('%g (%g waves/cm) - %s\n', peak_indexes(i), x(peak_indexes(i)), s);
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
