% function classes = renumber_classes(classes_orig, class_labels_orig, class_labels_ref)
%
% Renumbers classes_orig to match indexes in class_labels_ref
%
% If a label from class_labels_orig is not found in class_labels_ref, class is -1
function classes = renumber_classes(classes_orig, class_labels_orig, class_labels_ref)

no_obs = size(classes_orig, 1);
classes = ones(no_obs, 1)*-1;
for i = 1:no_obs
    new_class = find(strcmp(class_labels_orig{classes_orig(i)+1}, class_labels_ref))-1;
    if ~isempty(new_class)
        classes(i) = new_class;
    else
        classes(i) = -1;
    end;
end;
  
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
