% function resize_legend_markers(size=12, flag_line=0)
%
% size: size
% flag_line: if 0, resizes 'MarkerSize', else resizes 'LineWidth'
%
function resize_legend_markers(size, flag_line)

if ~exist('size')
    size = 12;
end;

if ~exist('flag_line')
    flag_line = 0;
end;


h = legend;
if isempty(h)
    disp('Warning: figure has no legend!');
else
    h_ = get(h, 'children');
    for i = 1:length(h_)
        hh_ = get(h_(i));
        if strcmp(hh_.Type, 'line')
            if flag_line
                set(h_(i),'LineWidth', size);
            else
                set(h_(i),'MarkerSize', size);
            end;
        end;
    end;
end;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
