% L = rotatefactors2(L, flag_normal)
%
% Reproduces the factor rotation of Pirouette
function L = rotatefactors2(L, flag_normal)

if ~exist('flag_normal')
    flag_normal = 0;
end;

s = 'None';
if flag_normal
    % Communality as defined in 5.39 of Pirouette.pdf (Pirouette User
    % Guide). There is one communality measure for each row of the loadings
    % matrix (i.e., each of the original features/wavenumbers).
    h = sqrt(sum(L.^2, 2));

    for i = 1:size(L, 1)
%         if h(i) ~= 0
            L(i, :) = L(i, :)/h(i);
%         end;
    end;
    
    s = 'Normal';
end;

L = rotatefactors(L, 'normalize', 'off');

if flag_normal
    for i = 1:size(L, 1)
        L(i, :) = L(i, :)*h(i);
    end;
end;

disp(sprintf('INFO: Loadings were rotated (pre-processing: ''%s'').', s));

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
