% flag_selected = select_load_mat_file()
% 
% Displays .mat files and lets user select one of them.
% 
% Returns:
%   flag_selected: 0 - no file was selected; 1 - a file was selected
function flag_selected = select_load_mat_file()
global IDEXPERIMENT EXPERIMENT_NAME NO_WAVENUMBERS IDJUDGE_REF CLASS_LABELS DATA

contents = dir('../mat/*.mat');
no_files = size(contents, 1);

option = -1;
if no_files == 0
    disp 'No .mat files avaiable!'
else
    disp('Avaiable files:')
    disp('  0 - *Cancel*')
    for i = 1:no_files
        disp(sprintf('%3d - %s', i, contents(i).name))
    end
    
    while 1
        option = input('>>> ');
        if option < 0 || option > no_files
            disp('Invalid option!, try again.')
        else
            break
        end
    end
    
    if option == 0
        disp('Nevermind.')
    else
        load_mat_file(['../mat/' contents(option).name]);
        
    end
end
        
flag_selected = option > 0;
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
