% function [model, est] = svm_estimate(model, data)
%
% Outputs:
%   model: the model itself
%   est: estimation structure
function [model, est] = svm_estimate(model, data)
est = est_new_from_model_data(model, data);

% Accuracy will not be correct because there may be class shifts in both
% the training and testing datasets.
tic();
[predict_label, accuracy, dec_values] = svmpredict(model_get_classes(model, data), data.X, model.svm);
model.time_estimate = toc();

est.classes = predict_label;
est.Y = dec_values; % TODO take a look at that, I don't know exactly what is in dec_values.
est.rate = est_get_rate(est, data);

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
