% load_mat_file('../mat/imran_pec29_oneclassonly.mat', [2100 200]);
load_mat_file('../mat/imran_pec29_cbn_1800_365_oneclass.mat', [1800, 365]);
global DATA;
ds01 = DATA;
ds01 = data_normalize(ds01, 'v', 20:180);


[no_obs, no_fea] = size(ds01.X);
ds03 = ds01;
% 
% % experimental baseline correction
% ds02 = ds01;
% range = 1:350;
% for i_obs = 1:no_obs
%     p = polyfit(range, ds02.X(i_obs, range), 1);
%     ds02.X(i_obs, :) = ds02.X(i_obs, :)-polyval(p, 1:no_fea);
% end;
% 

%%

ds02 = data_normalize(ds01, 's');
% stds = std(ds02.X);

THRESHZ = 5.5; % Number of std deviations above which a point will be considered a 1D outlier


disp('#Spec; start;   end; comments');
for i_obs = 1:no_obs
    % This is kind of a "signal parsing"
    bp = 0;
    cnt_out = 0;
    flag_pike = 0;
    for i_fea = 1:no_fea+1
        flag_out = ~(i_fea > no_fea) && abs(ds02.X(i_obs, i_fea)) > THRESHZ;
        
        if flag_out
            if ~flag_pike
                if i_fea > 1
                    if ds02.X(i_obs, i_fea) > 2*ds02.X(i_obs, i_fea-1)
                        flag_pike = 1;
                        bp = i_fea-1;
                    end;
                end;
            end;
                
            if flag_pike
                cnt_out = cnt_out+1;
            end;
        else
            if cnt_out > 0
                s = '';
                if cnt_out > 6
                    s = 'too wide';
                elseif bp == 0
                    s = 'not possible';
                elseif i_fea > no_fea
                    s = 'not possible';
                else
                    ds01.X(i_obs, bp:i_fea) = linspace(ds01.X(i_obs, bp), ds01.X(i_obs, i_fea), i_fea-bp+1);
                    s = 'SUCCESSFUL';
                end;
                fprintf('#%4d; %5d; %5d; %s\n', i_obs, bp, i_fea, s);
                flag_pike = 0;
                cnt_out = 0;
            end;
        end;
    end;
end;


while 1
    which = input('Which spectrum do you wanna see? ');
    if which == 0
        break;
    end;
    
    figure;
    plot(ds03.X(which, :));
    hold on;
    plot(ds01.X(which, :), 'r');
    legend({'Original', 'Despiked'});
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
