% function cc = est_get_confusion(est, data, flag_percentage=0)
%
% Inputs:
%   flag_percentage: whether to divide each row by its sum
% Outputs:
%   cc: confusion matrix
%
% Renumbers ypoll_correct.classes according to ypoll.class_labels and then calculates
% the confusion matrix
function cc = ypoll_get_confusion(ypoll, ypoll_correct, flag_percentage)

if ~exist('flag_percentage', 'var')
    flag_percentage = 0;
end;

no_classes = length(ypoll.class_labels);

classes_row = renumber_classes(ypoll_correct.classes, ypoll_correct.class_labels, ypoll.class_labels);
cc = calc_confusion(classes_row, ypoll.classes, flag_percentage, no_classes, no_classes);
% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
