% function rate = ypoll_get_rate(ypoll, ypoll_correct)
%
% Calculates the classification rate comparing too colony pools
function rate = ypoll_get_rate(ypoll, ypoll_correct)
if ~isempty(ypoll_correct.classes)
    rate = sum(strcmp(classes2labels(ypoll.classes, ypoll.class_labels), ...
                      classes2labels(ypoll_correct.classes, ypoll_correct.class_labels) ...
                     ))/length(ypoll.classes);
else
    rate = -1;
end;

% Copyright 2010 Julio Trevisan, Plamen P. Angelov & Francis L. Martin.
% e-mailing author: j.trevisan@lancaster.ac.uk
%
% This program is free software: you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the Free Software Foundation, either version 3 of the License, or
% (at your option) any later version.
% 
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
% 
% A copy of the GNU General Public License is shipped along with this
% program (filename: "COPYING").  For an online version of the license,
% see <http://www.gnu.org/licenses/>.
